﻿using System.Collections.Generic;
using ODM.Backend.Models.Models.Interfaces;

namespace ODM.Backend.Models.Models
{
	public class CompetitionResult : IDbItem, ICompetitionResult
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public int? CompetitionId { get; set; }
		public string Competitor { get; set; }
		public int Points { get; set; }
		public int? RegionId { get; set; }
	}

	public sealed class CompetitionResultComparer : IEqualityComparer<CompetitionResult>
	{
		public bool Equals(CompetitionResult x, CompetitionResult y)
		{
			if (x == null)
				return y == null;
			else if (y == null)
				return false;
			else
				return x.Id.Equals(y.Id)
				       && x.IsRemoved.Equals(y.IsRemoved)
				       && x.Competitor.Equals(y.Competitor)
				       && x.CompetitionId.Equals(y.CompetitionId)
				       && x.Points.Equals(y.Points)
				       && x.RegionId.Equals(y.RegionId);
		}

		public int GetHashCode(CompetitionResult obj)
		{
			unchecked
			{
				int hash = 17;

				hash = hash * 23 + (obj.Id).GetHashCode();
				hash = hash * 23 + (obj.IsRemoved).GetHashCode();
				hash = hash * 23 + (obj.Competitor ?? "").GetHashCode();
				hash = hash * 23 + (obj.CompetitionId).GetHashCode();
				hash = hash * 23 + (obj.Points).GetHashCode();
				hash = hash * 23 + (obj.RegionId).GetHashCode();

				return hash;
			}
		}
	}
}