﻿using System;
using System.Collections.Generic;
using System.Linq;

// ReSharper disable CheckNamespace

namespace ODM.Backend.Models.Models
{
	public class MessageAppData
	{
		public int Version{ get; set; }
		public List<Message> Messages { get; set; } = new List<Message>();

		public MessageAppData Merge(MessageAppData data)
		{
			this.Version = data.Version;

			var messagesDiff = data.Messages.Except(this.Messages, new MessageComparer());
			
			foreach (var message in messagesDiff)
			{
				var local = this.Messages.Find(m => m.Id == message.Id);
				if (local != null)
				{
					var index = this.Messages.IndexOf(local);
					this.Messages[index] = message;
				}
				else
				{
					Messages.Add(message);
				}
			}

			return this;
		}
	}
}