﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ODM.Backend.Models.Models
{
	public class ProgramAppData
	{
		public int Version { get; set; }

		public List<Competition> Competitions { get; set; } = new List<Competition>();
		public List<Event>	Events { get; set; } = new List<Event>();

		public ProgramAppData Merge(ProgramAppData data)
		{
			this.Version = data.Version;

			var competitionDiff = data.Competitions.Except(this.Competitions, new CompetitionComparer());

			foreach (var competition in competitionDiff)
			{
				var local = this.Competitions.Find(m => m.Id == competition.Id);
				if (local != null)
				{
					var index = this.Competitions.IndexOf(local);
					this.Competitions[index] = competition;
				}
				else
				{
					Competitions.Add(competition);
				}
			}

			var eventDiff = data.Events.Except(this.Events, new EventComparer());

			foreach (var eventResult in eventDiff)
			{
				var local = this.Events.Find(m => m.Id == eventResult.Id);
				if (local != null)
				{
					var index = this.Events.IndexOf(local);
					this.Events[index] = eventResult;
				}
				else
				{
					Events.Add(eventResult);
				}
			}

			return this;
		}
	}
}