﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ODM.Backend.Models.Models
{
	public class ResultAppData
	{
		public int Version { get; set; }

		public List<CompetitionResult> CompetitionResults { get; set;} = new List<CompetitionResult>();
		public List<EventResult> EventResults { get; set; } = new List<EventResult>();

		public ResultAppData Merge(ResultAppData data)
		{
			this.Version = data.Version;

			var competitionResultDiff = data.CompetitionResults.Except(this.CompetitionResults, new CompetitionResultComparer());

			foreach (var competitionResult in competitionResultDiff)
			{
				var local = this.CompetitionResults.Find(m => m.Id == competitionResult.Id);
				if (local != null)
				{
					var index = this.CompetitionResults.IndexOf(local);
					this.CompetitionResults[index] = competitionResult;
				}
				else
				{
					CompetitionResults.Add(competitionResult);
				}
			}

			var eventResultDiff = data.EventResults.Except(this.EventResults, new EventResultComparer());

			foreach (var eventResult in eventResultDiff)
			{
				var local = this.EventResults.Find(m => m.Id == eventResult.Id);
				if (local != null)
				{
					var index = this.EventResults.IndexOf(local);
					this.EventResults[index] = eventResult;
				}
				else
				{
					EventResults.Add(eventResult);
				}
			}

			return this;
		}
	}
}