﻿using System.Collections.Generic;
using ODM.Backend.Models.Models.Interfaces;

namespace ODM.Backend.Models.Models
{
	public class EventResult : IDbItem, IEventResult
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public string Competitor { get; set; }
		public int? EventId { get; set; }
		public int? RegionId { get; set; }
		public string Points { get; set; }
	}

	public sealed class EventResultComparer : IEqualityComparer<EventResult>
	{
		public bool Equals(EventResult x, EventResult y)
		{
			if (x == null)
				return y == null;
			else if (y == null)
				return false;
			else
				return x.Id.Equals(y.Id)
				       && x.IsRemoved.Equals(y.IsRemoved)
				       && x.Competitor.Equals(y.Competitor)
				       && x.EventId.Equals(y.EventId)
				       && x.RegionId.Equals(y.RegionId)
				       && x.Points.Equals(y.Points);
		}

		public int GetHashCode(EventResult obj)
		{
			unchecked
			{
				int hash = 17;

				hash = hash * 23 + (obj.Id).GetHashCode();
				hash = hash * 23 + (obj.IsRemoved).GetHashCode();
				hash = hash * 23 + (obj.Competitor ?? "").GetHashCode();
				hash = hash * 23 + (obj.EventId).GetHashCode();
				hash = hash * 23 + (obj.RegionId).GetHashCode();
				hash = hash * 23 + (obj.Points).GetHashCode();

				return hash;
			}
		}
	}
}