﻿using System.Collections.Generic;
using ODM.Backend.Models.Models.Interfaces;

namespace ODM.Backend.Models.Models
{
	public class Region : IRegion, IDbItem
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public string Name { get; set; }

		public Region()
		{

		}

		public Region(int id, string name)
		{
			Id = id;
			Name = name;
		}
	}

	public sealed class RegionComparer : IEqualityComparer<Region>
	{
		public bool Equals(Region x, Region y)
		{
			if (x == null)
				return y == null;
			else if (y == null)
				return false;
			else
				return x.Id.Equals(y.Id)
					   && x.IsRemoved.Equals(y.IsRemoved)
					   && x.Name.Equals(y.Name);

		}

		public int GetHashCode(Region obj)
		{
			unchecked
			{
				int hash = 17;

				hash = hash * 23 + (obj.Id).GetHashCode();
				hash = hash * 23 + (obj.IsRemoved).GetHashCode();
				hash = hash * 23 + (obj.Name).GetHashCode();

				return hash;
			}
		}
	}
}