﻿using System.Collections.Generic;
using ODM.Backend.Models.Models.Interfaces;

namespace ODM.Backend.Models.Models
{
	public class Sport : ISport, IDbItem 
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public IdItem Item { get; set; }

		public Sport(int id, string itemId, string name)
		{
			Id = id;
			this.Item = new IdItem(itemId, name);
		}

		public Sport()
		{
			
		}

		public override string ToString()
		{
			return Item.Name;
		}
	}

	public sealed class SportComparer : IEqualityComparer<Sport>
	{
		public bool Equals(Sport x, Sport y)
		{
			if (x == null)
				return y == null;
			else if (y == null)
				return false;
			else
				return x.Id.Equals(y.Id)
				       && x.IsRemoved.Equals(y.IsRemoved)
				       && x.Item.Name.Equals(y.Item.Name)
				       && x.Item.Key.Equals(y.Item.Key);
		}

		public int GetHashCode(Sport obj)
		{
			unchecked
			{
				int hash = 17;

				hash = hash * 23 + (obj.Id).GetHashCode();
				hash = hash * 23 + (obj.IsRemoved).GetHashCode();
				hash = hash * 23 + (obj.Item.Name).GetHashCode();
				hash = hash * 23 + (obj.Item.Key).GetHashCode();

				return hash;
			}
		}
	}
}