﻿// ReSharper disable CheckNamespace
namespace ODM.Backend.Models.Models
{
	/// <summary>
	/// Třída sloužící k uložení adresy
	/// </summary>
	public class Address
	{
		/// <summary>
		/// Ulice
		/// </summary>
		public string Street { get; set; }

		/// <summary>
		/// Číslo popisné
		/// </summary>
		public string StreetNumber { get; set; }

		/// <summary>
		/// Město
		/// </summary>
		public string City { get; set; }

		public Address(string street, string streetNumber, string city)
		{
			Street = street;
			StreetNumber = streetNumber;
			City = city;
		}

		public Address()
		{
			
		}

		/// <summary>
		/// Jednořádková adresa složená dohromady
		/// </summary>
		/// <returns></returns>
		public string SingleLineAddress
		{
			get
			{
				return $"{Street} {StreetNumber} {City}";
			}
		}

		/// <summary>
		/// adresa na tři řádky (bez PSČ)
		/// </summary>
		public string MultiLineAddress
		{
			get { return $"{Street} {StreetNumber}\n{City}"; }
		}
	}
}