﻿// ReSharper disable CheckNamespace
namespace ODM.Backend.Models.Models
{
	public class Gps
	{
		/// <summary>
		/// Zeměpisná šířka
		/// </summary>
		public double Latitude { get; set; }
		/// <summary>
		/// Zeměpisná délka
		/// </summary>
		public double Longitude { get; set; }

		public Gps()
		{
			
		}

		public Gps(double latitude, double longitude)
		{
			Latitude = latitude;
			Longitude = longitude;
		}

		/// <summary>
		/// Vypíše vlastnosti třídy
		/// </summary>
		/// <returns></returns>
		public override string ToString()
		{
			return $"{Latitude}:{Longitude}";
		}

		public override bool Equals(object obj)
		{
			if (ReferenceEquals(null, obj))
				return false;
			if (ReferenceEquals(this, obj))
				return true;
			if (obj.GetType() != GetType())
				return false;
			return Equals((Gps)obj);
		}

		bool Equals(Gps other)
		{
			return double.Equals(Latitude, other.Latitude) && double.Equals(Longitude, other.Longitude);
		}
	}
}