﻿using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Device;

namespace Skeleton.Mobile.ODM.Backend.DataAccess.InternalStorage
{
	public static class InternalStorage
	{
		/// <summary>
		/// uloží nová data do interního uložiště
		/// </summary>
		/// <returns></returns>
		public static async Task CopyTo(byte[] data, string fileName)
		{
			var dataManager = Device.Instance.GetInternalFileManager(fileName);
			if (dataManager.Exists())
			{
				await dataManager.Delete();
			}
			await dataManager.CreateAndWriteBytes(data);
		}
	}
}