﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Data.Manager;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class CompetitionResultManager : AbsManager
	{
		public async Task<List<CompetitionResult>> GetAll()
		{
			try
			{
				var result = (await DataManager.GetResultData()).CompetitionResults;
				return result;
			}
			catch(Exception exception)
			{
				await this.HandleException(exception);
				return null;
			}
		}

		public async Task<List<CompetitionResult>> GetByComp(Competition comp)
		{
			var all = await GetAll();
			var results = all.Where(r => r.CompetitionId == comp.Id).ToList();
			return results;
		}
	}
}