﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Data.Manager;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class EventResultManager : AbsManager
	{
		public async Task<List<EventResult>> GetAll()
		{
			try
			{
				var result = (await DataManager.GetResultData()).EventResults;
				return result;
			}
			catch (Exception exception)
			{
				await this.HandleException(exception);
				return null;
			}
		}

		public async Task<List<EventResult>> GetByEvent(Event eventModel)
		{
			var all = await GetAll();
			var results = all.Where(r => r.EventId == eventModel.Id).ToList();
			return results;
		}
	}
}