﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Data.Manager;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class FoodManager : AbsManager
	{
		/// <summary>
		/// Vrátí seznam meals podle meal typu
		/// </summary>
		public async Task<List<Meal>> GetMealsByMenu(Menu menu)
		{
			try
			{
				var result = (await DataManager.GetStaticData()).Meals;
				return result?.Where(m => m.MenuId == menu.Id).ToList();
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}

		/// <summary>
		/// Vrátí seznam všech meal types
		/// </summary>
		public async Task<List<Menu>> GetMenus()
		{
			try
			{
				var result = (await DataManager.GetStaticData()).Menus;
				return result;
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}
	}
}