﻿using Skeleton.Mobile.Framework.Data.Manager;
using Skeleton.Mobile.ODM.Backend.Models;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class NotificationManager : AbsManager
	{
		public static int MinutesBeforeEvent = 60;
		
		public List<Notification> GetAllNotifications()
		{
			return SettingsManager.Notifications.GetAllNotifications();
		}

		public Notification GetNotification(int id)
		{
			return GetAllNotifications().Find(n => n.NotificationId == id);
		}

		public Notification GetNotificationByEventId(int id){
			return GetAllNotifications().Find(n => n.EventId == id);
		}

		public async Task<Notification> AddNotification(Notification notif)
		{
			try
			{
				SettingsManager.Notifications.AddNotification(notif);
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
			return notif;
		}

		public void RemoveNotification(Notification notif)
		{
			SettingsManager.Notifications.RemoveNotification(notif);
		}

		public void RemoveNotificationById(int id)
		{
			SettingsManager.Notifications.RemoveNotificationById(id);
		}

		public void RemoveAllNotifications(bool uSureQuestionMark = false)
		{
			if (uSureQuestionMark)
			{
				SettingsManager.Notifications.Clear(uSureQuestionMark);
			}
		}
	}
}
