﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Data.Manager;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class RegionManager :AbsManager
	{
		/// <summary>
		/// Vrátí region podle id
		/// </summary>
		/// <param name="id">id místa</param>
		/// <returns></returns>
		public async Task<Region> GetById(int id)
		{
			try
			{
				var output = await GetAll();
				return output.Single(x => x.Id == id);
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}

		/// <summary>
		/// Vrátí seznam všech regionů
		/// </summary>
		/// <returns></returns>
		public async Task<List<Region>> GetAll()
		{
			try
			{
				var result = (await DataManager.GetStaticData()).Regions;
				return result;
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}
	}
}