﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Data.Manager;

namespace Skeleton.Mobile.ODM.Backend.Managers
{
	public class SportManager : AbsManager
	{
		/// <summary>
		/// Vrátí seznam všech sportů
		/// </summary>
		/// <returns></returns>
		public async Task<List<Sport>> GetAll()
		{
			try
			{
				var result = (await DataManager.GetStaticData()).Sports;

				return result;
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}

		public async Task<Sport> GetById(int? id)
		{
			try
			{
				var result = await this.GetAll();
				return result.Find(s => s.Id == id);
			}
			catch (Exception ex)
			{
				await this.HandleException(ex);
				return null;
			}
		}

	}
}