﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Support.V4.App;
using Android.Views;
using Android.Widget;
using Skeleton.Mobile.ODM.Backend.Models;
using Skeleton.Mobile.ODM.DependencyServices;
using Skeleton.Mobile.ODM.Droid.Notifications;
using Xamarin.Forms;

[assembly: Dependency(typeof(Skeleton.Mobile.ODM.Droid.DependencyServices.Notifications))]
namespace Skeleton.Mobile.ODM.Droid.DependencyServices
{
	public class Notifications : INotifications
	{
		readonly AlarmManager alarmManager;
		public static int AppIconResourceId { get; set; }

		static Notifications()
		{
			AppIconResourceId = Android.App.Application.Context.Resources.GetIdentifier("logo", "drawable", Android.App.Application.Context.PackageName);
		}

		public Notifications()
		{
			this.alarmManager = (AlarmManager)Android.App.Application.Context.GetSystemService(Context.AlarmService);
		}

		public async Task Send(Backend.Models.Notification notification)
		{
			await this.alarmManager.ScheduleNotification(notification);
		}


		public Task CancelByNotificationId(int notificationId)
		{
			this.CancelByNotificationIdInternal(notificationId);
			return Task.FromResult(true);
		}

		public Task<bool> RequestPermission() => Task.FromResult(true);


		protected virtual void CancelByNotificationIdInternal(int notificationId)
		{
			var pending = Helpers.GetNotificationPendingIntent(notificationId);
			pending.Cancel();

			this.alarmManager.Cancel(pending);
			NotificationManagerCompat
				.From(Android.App.Application.Context)
				.Cancel(notificationId);
		}
	}
}