﻿using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using System.Reflection;
using System.Threading.Tasks;
using Android.Content;
using Android.Content.Res;
using Android.Net;
using Android.Util;
using Xamarin.Forms;
using Java.Lang;
using Rg.Plugins.Popup.Services;
using Skeleton.Mobile.Framework.Device.Droid.Picture;
using Xamarin.Forms.Platform.Android;
using Device = Skeleton.Mobile.Framework.Device.Device;
using Skeleton.Mobile.Framework.Error.Log;
using ActionMode = Android.Support.V7.View.ActionMode;
using Skeleton.Mobile.ODM.Droid;
using Skeleton.Mobile.ODM.Droid.DependencyServices;
using Skeleton.Mobile.Framework.Tools.Droid.Extensions;
using Skeleton.Mobile.ODM.Tools;

[assembly: ExportRenderer(typeof(Skeleton.Mobile.Framework.Controls.Forms.Map.Map.Map), typeof(Skeleton.Mobile.Framework.Controls.Forms.Droid.Map.Renderers.MapRenderer))]

namespace Skeleton.Mobile.ODM.Droid
{
	[Activity(Theme = "@style/MainTheme", MainLauncher = false, ScreenOrientation = ScreenOrientation.Portrait, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
	public class MainActivity : Framework.Error.Forms.Droid.GlobalExceptionHandling.ExceptionActivity
	{
		protected override void OnCreate(Bundle bundle)
		{
			TabLayoutResource = Resource.Layout.Tabbar;
			ToolbarResource = Resource.Layout.Toolbar;

			base.OnCreate(bundle);
			Rg.Plugins.Popup.Popup.Init(this, bundle);

			global::Xamarin.Forms.Forms.Init(this, bundle);

			if (!Framework.Device.Device.IsDeviceInitialized)
			{
				Framework.Device.Device.Instance = new Framework.Device.Droid.Device(this, Assembly.GetExecutingAssembly());
			}
			else
			{
				(Framework.Device.Device.Instance as Framework.Device.Droid.Device).RefreshContext(this);
			}
			this.CreateNotificationChannels();

			StatusBar.Activity = this;

			LoadApplication(new App());
		}

		public override void OnSupportActionModeStarted(ActionMode mode)
		{
			Window.SetStatusBarColor(Color.FromHex("#0e3a82").ToAndroid());
			base.OnSupportActionModeStarted(mode);
		}

		public override void OnSupportActionModeFinished(ActionMode mode)
		{
			Window.SetStatusBarColor(Color.FromHex("#12479e").ToAndroid());
			base.OnSupportActionModeFinished(mode);
		}

		public event ActivityResultDelegate ActivityResult;

		protected override void OnActivityResult(int requestCode, Result resultCode, Intent data)
		{
			base.OnActivityResult(requestCode, resultCode, data);
			this.OnMyActivityResult(requestCode, resultCode, data);
		}
		private void OnMyActivityResult(int requestCode, Result resultCode, Intent data)
		{
			this.ActivityResult?.Invoke(requestCode, resultCode, data);
		}
		public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Permission[] grantResults)
		{
			Framework.Device.Droid.Permissions.PermissionsManager.OnRequestPermissionsResult(requestCode, permissions, grantResults);
		}

		public override async void OnBackPressed()
		{
			if (Rg.Plugins.Popup.Popup.SendBackPressed())
			{
				// Do something if there are some pages in the `PopupStack`
				await PopupNavigation.Instance.PopAsync();
			}
			else
			{
				base.OnBackPressed();
			}
		}
		/// <summary>
		/// Vytvoření kanálů pro notifikace
		/// </summary>
		private void CreateNotificationChannels()
		{
			this.CreateNotificationChannel(NotificationFactory.EventsChannelId,
				"Notification_EventChannelName".LocalizeResx(), "Notification_EventChannelDescription".LocalizeResx(),
				NotificationImportance.Default);
		}
	}
}

