﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Skeleton.Mobile.Framework.Error.Log;

namespace Skeleton.Mobile.ODM.Droid.Notifications
{
	[BroadcastReceiver(Enabled = true, Label = "Reboot Broadcast Receiver")]
	[IntentFilter(new[] { Android.Content.Intent.ActionBootCompleted })]
	public class RebootBroadcastReceiver : BroadcastReceiver
	{
		public override async void OnReceive(Context context, Intent intent)
		{
			if (!Framework.Device.Device.IsDeviceInitialized)
			{
				Framework.Device.Device.Instance = new Framework.Device.Droid.Device(context, Assembly.GetExecutingAssembly());
			}

			try
			{
				await ErrorLog.Instance.AddRecord(ErrorTypes.MESSAGE, "RebootBroadcastReceiver started after restart.",
					"Notifications are to be scheduled.");

				var alarmManager = (AlarmManager)Application.Context.GetSystemService(Context.AlarmService);

				var manager = new ODM.Backend.Managers.NotificationManager();
				var notifications = manager.GetAllNotifications();
				foreach (var notification in notifications)
				{
					await alarmManager.ScheduleNotification(notification);
				}
			}
			catch (Exception e)
			{
				ErrorLog.Instance.StartAddExceptionRecord(true, e);
			}
		}
	}
}