﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;
using Foundation;
using Skeleton.Mobile.Framework.Controls.Forms.Inputs;
using Skeleton.Mobile.Framework.Controls.Forms.iOS.Map.Renderers;
using Skeleton.Mobile.Framework.Controls.Forms.iOS.Renderers;
using Skeleton.Mobile.Framework.Controls.Forms.ProgressIndication;
using Skeleton.Mobile.Framework.Error.Log;
using Skeleton.Mobile.ODM.Converters;
using Skeleton.Mobile.ODM.iOS.Notifications;
using Skeleton.Mobile.ODM.Tools;
using UIKit;
using Xamarin.Forms;

[assembly: ExportRenderer(typeof(CheckBox), typeof(CheckBoxRenderer))]
[assembly: ExportRenderer(typeof(IconButton), typeof(IconButtonRenderer))]
[assembly: ExportRenderer(typeof(IndeterminateProgressBar), typeof(InderminateProgressBarRenderer))]
[assembly: ExportRenderer(typeof(IconLabel), typeof(IconLabelRenderer))]
[assembly: ExportRenderer(typeof(ImageCircle), typeof(ImageCircleRenderer))]
[assembly: ExportRenderer(typeof(Skeleton.Mobile.Framework.Controls.Forms.Inputs.Picker), typeof(PickerRenderer))]
[assembly: ExportRenderer(typeof(Skeleton.Mobile.Framework.Controls.Forms.Map.Map.Map), typeof(MapRenderer))]
namespace Skeleton.Mobile.ODM.iOS
{
	// The UIApplicationDelegate for the application. This class is responsible for launching the 
	// User Interface of the application, as well as listening (and optionally responding) to 
	// application events from iOS.
	[Register("AppDelegate")]
	public partial class AppDelegate : global::Xamarin.Forms.Platform.iOS.FormsApplicationDelegate
	{
		//
		// This method is invoked when the application has loaded and is ready to run. In this 
		// method you should instantiate the window, load the UI into it and then make the window
		// visible.
		//
		// You have 17 seconds to return from this method, or iOS will terminate your application.
		//
		public override bool FinishedLaunching(UIApplication app, NSDictionary options)
		{
			Rg.Plugins.Popup.Popup.Init();
			global::Xamarin.Forms.Forms.Init();
			Skeleton.Mobile.Framework.Device.Device.Instance = new Framework.Device.iOS.Device(Assembly.GetExecutingAssembly(), NSBundle.MainBundle);

			LoadApplication(new App());
			return base.FinishedLaunching(app, options);
		}


		public async override void ReceivedLocalNotification(UIApplication application, UILocalNotification notification)
		{
			var info = notification.UserInfo.FromNsDictionary();
			//var ndi = NotificationFactory.GetNotificationInfo(info);
			//if (ndi != null)
			//{
				if (application.ApplicationState == UIApplicationState.Active)
				{
					//await this.HandleNotificationForeground(ndi, notification);
				}
				else
				{
				//await this.HandleNotificationBackground(ndi);
				LoadApplication(new App());
				}
			//}
			//else
			//{
			//	await ErrorLog.Instance.AddRecord(ErrorTypes.ERROR, info.ToString(), "NotificationData have unknown format");
			//}
		}

		//private async Task HandleNotificationForeground(NotificationDetailInfo ndi, UILocalNotification notification)
		//{
		//	var result = await Skeleton.Mobile.Framework.Device.Device.Instance.Dialogs.ShowDialog(notification.AlertTitle, notification.AlertBody, "Notification_DisplayButton".LocalizeResx(), "Notification_CancelButton".LocalizeResx());
		//	if (result == Framework.Device.Tools.DialogResult.Accepted)
		//	{
		//		if (App.Current is App currentApp)
		//			await currentApp.RedirectNavigation(ndi);
		//		else
		//			ErrorLog.Instance.StartAddRecord(ErrorTypes.ERROR, $"AppDelegate (Notification) - Unknown application type - {App.Current}");
		//	}
		//}

		//private async Task HandleNotificationBackground(NotificationDetailInfo ndi)
		//{
		//	if (App.Current is App currentApp)
		//		await currentApp.RedirectNavigation(ndi);
		//	else
		//	{
		//		LoadApplication(new App());
		//		ErrorLog.Instance.StartAddRecord(ErrorTypes.WARNING, App.Current?.ToString(), "AppDelegate.HandleNotificationBackground", "App.Current is null or unknown type");
		//	}
		//}
	}
}

