﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Foundation;
using Skeleton.Mobile.ODM.Backend.Models;
using Skeleton.Mobile.ODM.DependencyServices;
using Skeleton.Mobile.ODM.iOS.Notifications;
using UIKit;
using Xamarin.Forms;

[assembly: Dependency(typeof(Skeleton.Mobile.ODM.iOS.DependencyServices.Notifications))]
namespace Skeleton.Mobile.ODM.iOS.DependencyServices
{
	public class Notifications : INotifications
	{
		readonly INotifications impl;

		public Notifications()
		{
			if (UIDevice.CurrentDevice.CheckSystemVersion(10, 0))
				this.impl = new UNNotificationsImpl();
			else
				this.impl = new UILocalNotificationsImpl();
		}

		public Task CancelByNotificationId(int notificationId) => this.impl.CancelByNotificationId(notificationId);
		public Task Send(Notification notification) => this.impl.Send(notification);
		public Task<bool> RequestPermission() => this.impl.RequestPermission();
	}
}