﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Foundation;
using Skeleton.Mobile.ODM.Backend.Models;
using Skeleton.Mobile.ODM.DependencyServices;
using Skeleton.Mobile.ODM.Tools;
using UIKit;

namespace Skeleton.Mobile.ODM.iOS.Notifications
{
	public abstract class AbstractAppleNotificationsImpl : INotifications
	{
		public abstract Task<bool> RequestPermission();
        public abstract Task CancelByNotificationId(int notificationId);
        public abstract Task Send(Notification notification);

        protected Task Invoke(Action action)
        {
            var tcs = new TaskCompletionSource<object>();
            UIApplication.SharedApplication.InvokeOnMainThread(() =>
            {
                action();
                tcs.TrySetResult(null);
            });
            return tcs.Task;
        }

        /// <summary>
        /// Vytvoří NSDictionary s potřebnými doplňujícími informacemi o notifikaci (id a typ)
        /// </summary>
        /// <returns></returns>
        protected NSMutableDictionary CreateUserInfoDictionary(Notification notification)
        {
            object[] values = { notification.EventId };
            object[] keys = { NotificationFactory.EventIdKey };

            NSMutableDictionary nsDictionary = NSMutableDictionary.FromObjectsAndKeys(values, keys);

            return nsDictionary;
        }

		public Task RegisterToPushNotificationNews()
		{
			throw new NotImplementedException();
		}
	}
}