﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Foundation;
using UIKit;

namespace Skeleton.Mobile.ODM.iOS.Notifications
{
	public static class Extensions
	{
		static DateTime reference = new DateTime(2001, 1, 1, 0, 0, 0, 0, DateTimeKind.Utc);

		public static DateTime ToDateTime(this NSDate date)
		{
			var utcDateTime = reference.AddSeconds(date.SecondsSinceReferenceDate);
			var dateTime = utcDateTime.ToLocalTime();
			return dateTime;
		}

		public static NSDate ToNSDate(this DateTime datetime)
		{
			var utcDateTime = datetime.ToUniversalTime();
			var date = NSDate.FromTimeIntervalSinceReferenceDate((utcDateTime - reference).TotalSeconds);
			return date;
		}

		public static NSDictionary ToNsDictionary(this IDictionary<string, int> dict)
		{
			var ns = new NSMutableDictionary();
			foreach (var pair in dict)
				ns.SetValueForKey(new NSNumber(pair.Value), new NSString(pair.Key));

			return ns;
		}

		public static IDictionary<string, int> FromNsDictionary(this NSDictionary ns)
		{
			var dict = new Dictionary<string, int>();
			if (ns != null)
			{
				foreach (var pair in ns)
				{
					if (pair.Value is NSNumber)
					{
						dict.Add(pair.Key.ToString(), ((NSNumber)pair.Value).Int32Value);
					}
				}
			}
			return dict;
		}
	}
}