﻿using System;
using System.Globalization;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.ODM.Tools;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	public class GenderToTextConverter : IValueConverter
	{
		/// <param name="value">Gender enum</param>
		/// <param name="parameter">False = jednotné číslo, True = množné číslo</param>
		/// <returns>chlapec / dívka, chlapci / dívky</returns>
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is Gender)
			{
				if (parameter is bool b && b)
				{
					switch (value)
					{
						case Gender.Female:
							return "Females".LocalizeResx();
						case Gender.Male:
							return "Males".LocalizeResx();
						case Gender.Unspecified:
							return "";
						default:
							return "";
					}
				}
				switch (value)
				{
					case Gender.Female:
						return "Female".LocalizeResx();
					case Gender.Male:
						return "Male".LocalizeResx();
					case Gender.Unspecified:
						return "";
					default:
						return "";
				}
			}

			return "";
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}