﻿using System;
using System.Globalization;
using ODM.Backend.Models.Models;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	class GpsToStringConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is Gps)
			{
				Gps gps = (Gps)value;
				string longitudeFlag = gps.Longitude < 0 ? "W" : "E";
				string latitudeFlag = gps.Latitude < 0 ? "S" : "N";
				double absLongitude = Math.Abs(gps.Longitude);
				double absLatitude = Math.Abs(gps.Latitude);
				return $"{absLatitude:F6}{latitudeFlag}; {absLongitude:F6}{longitudeFlag}";
			}
			return value;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
