﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;
using ODM.Backend.Models.Enums;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	class MessageTopicToColorConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (!(value is MessageTopicEnum))
			{
				return (Color)App.Current.Resources["SecondaryBackgroundColor"];
			}
			MessageTopicEnum topic = (MessageTopicEnum)value;

			switch (topic)
			{
				case MessageTopicEnum.NoTopic:
					{
						return (Color)App.Current.Resources["SecondaryBackgroundColor"];
					}
				case MessageTopicEnum.Announcement:
					{
						return (Color)App.Current.Resources["GreenColor"];
					}
				case MessageTopicEnum.Invitation:
					{
						return (Color)App.Current.Resources["YellowColor"];
					}
				case MessageTopicEnum.ProgramChange:
					{
						return (Color)App.Current.Resources["BlueColor"];
					}
				case MessageTopicEnum.TransportChange:
					{
						return (Color)App.Current.Resources["BlackColor"];
					}
				case MessageTopicEnum.Update:
					{
						return Color.Cyan;
					}
				default:
					{
						return (Color)App.Current.Resources["SecondaryBackgroundColor"];
					}
			}
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
