﻿using System;
using System.Globalization;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.ODM.Tools;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	public class MessageTopicToNameConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is MessageTopicEnum)
			{
				var vTEnum = (MessageTopicEnum)value;
				
					switch (vTEnum)
					{
						case MessageTopicEnum.Announcement:
							return "MessageTopic_Announcement".LocalizeResx();
						case MessageTopicEnum.Invitation:
							return "MessageTopic_Invitation".LocalizeResx();
						case MessageTopicEnum.ProgramChange:
							return "MessageTopic_ProgramChange".LocalizeResx();
						case MessageTopicEnum.TransportChange:
							return "MessageTopic_TransportChange".LocalizeResx();
						case MessageTopicEnum.Update:
							return "MessageTopic_Update".LocalizeResx();
						case MessageTopicEnum.NoTopic:
							return "MessageTopic_NoTopic".LocalizeResx();
						default:
							return value;
					}
			}

			return value;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}