﻿using System;
using System.Collections;
using System.Globalization;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	class ObjectToVisibilityConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value == null)
			{
				return false;
			}

			if (value is string)
			{
				return !string.IsNullOrEmpty((string)value);
			}

			if (value is IList)
			{
				if (((IList)value).Count == 0)
				{
					return false;
				}
				else
				{
					return true;
				}
			}

			if (value is ICollection)
			{
				if (((ICollection)value).Count == 0)
				{
					return false;
				}
				else
				{
					return true;
				}
			}

			if (value is FormattedString)
			{
				if (((FormattedString)value).Spans == null || ((FormattedString)value).Spans.Count == 0)
				{
					return false;
				}
				else
				{
					return true;
				}
			}

			return true;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
