﻿using System;
using System.Globalization;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.ODM.Tools;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	public class VenueTypeToColorConverter : IValueConverter
	{
		//<Color x:Key="MapPinSportColor">#0d4da1</Color>
		//<Color x:Key="MapPinSportInterestedColor">#ee1d23</Color>>
		//<Color x:Key="MapPinCanteenColor">#00ab54</Color>
		//<Color x:Key="MapPinHousingColor">#fbb033</Color>
		//<Color x:Key="MapPinBusColor">#231f20</Color>


		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is VenueTypeEnum)
			{
				var vTEnum = (VenueTypeEnum)value;

				switch (vTEnum)
				{
					case VenueTypeEnum.Housing:
						return (Color)App.Current.Resources["MapPinHousingColor"];

					case VenueTypeEnum.Sport:
						return (Color)App.Current.Resources["MapPinSportColor"];

					case VenueTypeEnum.Canteen:
						return (Color)App.Current.Resources["MapPinCanteenColor"];

					case VenueTypeEnum.Bus:
						return (Color)App.Current.Resources["MapPinBusColor"];
					default:
						return Color.White;
				}
			}

			return Color.White;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}