﻿using System;
using System.Globalization;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.ODM.Tools;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Converters
{
	public class VenueTypeToNameConverter : IValueConverter
	{
		// VenueType_Canteen
		// VenueType_Sport
		// VenueType_Housing
		// VenueType_Bus


		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is VenueTypeEnum)
			{
				var vTEnum = (VenueTypeEnum)value;

				if (parameter is bool && (bool)parameter)
				{
					switch (vTEnum)
					{
						case VenueTypeEnum.Sport:
							return "VenueType_Sport".LocalizeResx();
						case VenueTypeEnum.Canteen:
							return "VenueType_CanteenPlural".LocalizeResx();
						case VenueTypeEnum.Housing:
							return "VenueType_Housing".LocalizeResx();
						case VenueTypeEnum.Bus:
							return "VenueType_BusPlural".LocalizeResx();
						default:
							return value;
					}
				}

				switch (vTEnum)
				{
					case VenueTypeEnum.Sport:
						return "VenueType_Sport".LocalizeResx();
					case VenueTypeEnum.Canteen:
						return "VenueType_Canteen".LocalizeResx();
					case VenueTypeEnum.Housing:
						return "VenueType_Housing".LocalizeResx();
					case VenueTypeEnum.Bus:
						return "VenueType_Bus".LocalizeResx();
					default:
						return value;
				}
			}

			return value;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			if (value is string)
			{
				var sEnum = (string)value;

				string sport = "VenueType_Sport".LocalizeResx();
				string housing = "VenueType_Housing".LocalizeResx();
				string canteen = "VenueType_Canteen".LocalizeResx();
				string bus = "VenueType_Bus".LocalizeResx();

				if (parameter is bool && (bool)parameter)
				{
					string canteenP = "VenueType_CanteenPlural".LocalizeResx();
					string busP = "VenueType_BusPlural".LocalizeResx();

					if (sEnum == sport)
						return VenueTypeEnum.Sport;
					else if (sEnum == canteenP)
						return VenueTypeEnum.Canteen;
					else if (sEnum == housing)
						return VenueTypeEnum.Housing;
					else if (sEnum == busP)
						return VenueTypeEnum.Bus;
					else
						return value;
				}
				if (sEnum == sport)
					return VenueTypeEnum.Sport;
				else if (sEnum == canteen)
					return VenueTypeEnum.Canteen;
				else if (sEnum == housing)
					return VenueTypeEnum.Housing;
				else if (sEnum == bus)
					return VenueTypeEnum.Bus;
				else
					return value; 
			}

			return value;
		}
	}
}