﻿using Skeleton.Mobile.ODM.Backend.Models;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace Skeleton.Mobile.ODM.DependencyServices
{
	public interface INotifications
	{
		/// <summary>
		/// This is required on iOS to trigger permission request
		/// </summary>
		Task<bool> RequestPermission();

		/// <summary>
		/// Cancel a specific notification by notification ID
		/// </summary>
		/// <param name="notificationId">Jednoznačné id notifikace (PK v databázi)</param>
		/// <returns>Returns true if message found and cancelled successfully</returns>
		Task CancelByNotificationId(int notificationId);

		/// <summary>
		/// Send a notification
		/// </summary>
		/// <param name="notification"></param>
		/// <returns>The messageID that you can use to cancel with</returns>
		Task Send(Notification notification);
	}
}
