﻿using Skeleton.Mobile.Framework.Controls.Assistant;
using Skeleton.Mobile.Framework.Data.Manager;
using Skeleton.Mobile.Framework.Error.Forms.Tools;
using Skeleton.Mobile.ODM.Views;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Tools
{
	public class ManagerAssistant : AbsReportManagerAssistant<ErrorReportPage>
	{
		public ManagerAssistant(IBackgroundPage page, IManager manager, string loadingText, bool startPageBackgroundWorking = true, bool finishAfterError = false, bool showDialogAfterError = true, bool showDialogAfterNetworkError = true) : base(page, manager, loadingText, startPageBackgroundWorking, finishAfterError, showDialogAfterError, showDialogAfterNetworkError)
		{
		}

		public override IManagerAssistantFactory CreateFactoryInstance() => new AssistantFactory();
		protected override INavigation Navigation
		{
			get
			{
				if (RootPage.RootNavigationPage != null)
				{
					return RootPage.RootNavigationPage.Navigation;
				}
				else
				{
					return (App.Current as App).MainPage.Navigation;
				}
			}
		}
	}
}
