﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;

namespace Skeleton.Mobile.ODM.Tools
{
	public static class StringSimilarityComparison
	{
		public static bool AreSimilar(string query, string compared)
		{
			query = query.ToLower();
			compared = compared.ToLower();

			query = query.RemoveDiacritics();
			compared = compared.RemoveDiacritics();

			string[] queryWords = query.Split(' ');
			string[] comparedWords = compared.Split(' ');

			foreach (var queryWord in queryWords)
			{
				if (queryWord.Length > 2)
				{
					foreach (var comparedWord in comparedWords)
					{
						if (comparedWord.Contains(queryWord) && comparedWord.Length > 2)
						{
							return true;
						}
					}
				}
			}

			return false;
		}

		public static string RemoveDiacritics(this string text)
		{
			if (string.IsNullOrWhiteSpace(text))
				return text;

			text = text.Normalize(NormalizationForm.FormD);
			var chars = text.Where(c => CharUnicodeInfo.GetUnicodeCategory(c) != UnicodeCategory.NonSpacingMark).ToArray();
			return new string(chars).Normalize(NormalizationForm.FormC);
		}
	}
}