﻿using System;
using System.Windows.Input;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWebService.DL.Entities.Enums;
using Rg.Plugins.Popup.Services;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Views;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.ViewModels.Abstract
{
	public class CompetitionViewModel : CancellationViewModel, ICompetition
	{
		public CompetitionViewModel(Competition comp) : this()
		{
			this.Competition = comp;
			this.Discipline = comp.Discipline;
			this.Gender = comp.Gender;
			this.Race = comp.Race;
			this.SportId = comp.SportId;
		}

		public CompetitionViewModel()
		{
			ShowResultCommand = new Command(ShowResultCommand_Execute);
		}

		public ICommand ShowResultCommand { get; set; }
		public void ShowResultCommand_Execute()
		{
			ODMPage.SafeGoToPopupPage(new CompetitionResultPopupPage(Competition));
		}

		#region Properties

		public string Name => $"{Sport?.Item.Name} - {Discipline}: {Race}";
		public bool DisplayGender => Gender != Gender.Unspecified;
		protected bool IsOnVenuePage { get; set; }
		public Sport Sport
		{
			get => sport;
			set { sport = value; OnPropertyChanged(); OnPropertyChanged(nameof(Name)); }
		}
		public Venue Venue { get; protected set; }
		public string Discipline { get; set; }
		public Gender Gender { get; set; }
		public string Race { get; set; }
		public int? SportId { get; set; }
		public Competition Competition { get; protected set; }

		#endregion

		#region Fields

		protected Sport sport;
		protected string city;

		#endregion

		//TODO: změna interfacu
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
	}
}