﻿using System;
using System.Collections.Generic;
using System.Linq;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;

namespace Skeleton.Mobile.ODM.ViewModels.Abstract
{
	public abstract class VenueViewModel : CancellationViewModel
	{
		private Venue model;

		protected VenueViewModel(Venue model)
		{
			this.Model = model;
		}

		public int Id => Model.Id;

		public Gps VenueLocation => this.Model.Location;

		public string Name => Model.Name;

		public VenueTypeEnum Type => Model.Type;

		public string City => this.Model.Address.City;

		public string Address
		{
			get
			{
				List<string> addressRows = new List<string>();
				if (this.Model.Address != null)
				{
					string first = string.Empty;
					if (!string.IsNullOrEmpty(this.Model.Address.Street))
					{
						first += this.Model.Address.Street;

						if (!string.IsNullOrEmpty(this.Model.Address.StreetNumber))
						{
							first += " ";
							first += this.Model.Address.StreetNumber;
						}
					}
					addressRows.Add(first);

					string second = String.Empty;

					if (!string.IsNullOrEmpty(this.Model.Address.City))
					{
						second += this.Model.Address.City;
					}

					addressRows.Add(second);
				}
				return string.Join(Environment.NewLine, addressRows.Where(x => !string.IsNullOrEmpty(x)));
			}
		}

		protected Venue Model { get => model; private set => model = value; }
	}
}