﻿using System.Collections.Generic;
using System.Linq;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;

namespace Skeleton.Mobile.ODM.ViewModels.ComponentViewModels
{
	public class EventCalendarViewModel
	{
		private List<EventItemCalendarViewModel> Events { get; set; }

		public Dictionary<string, List<EventItemCalendarViewModel>> HourlyEvents =
			new Dictionary<string, List<EventItemCalendarViewModel>>(24);

		public EventCalendarViewModel(List<EventItemCalendarViewModel> events)
		{
			this.Events = events;
			SetupHourlyEvents();
		}

		private void SetupHourlyEvents()
		{
			for (int i = 0; i < 24; i++)
			{
				string h = i.ToString();
				if (i < 10)
				{
					h = $"0{i}";
				}

				HourlyEvents[$"{h}:00"] = Events.Where(e => e.Start.Hour == i).ToList();
			}
			List<string> keys = new List<string>();
			foreach (var keyValuePair in HourlyEvents)
			{
				if (keyValuePair.Value.Count == 0)
				{
					keys.Add(keyValuePair.Key);
				}
			}
			foreach (var key in keys)
			{
				HourlyEvents.Remove(key);
			}
		}
	}
}