﻿using System;
using System.Collections.Generic;
using System.Linq;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;

namespace Skeleton.Mobile.ODM.ViewModels.ComponentViewModels
{
	public class MenuDateViewModel : ViewModel
	{
		public List<MealItemViewModel> BreakfastMeals => Meals?.Where(m => m.Type == MealType.Breakfast).ToList();
		public List<MealItemViewModel> MorningSnackMeals => Meals?.Where(m => m.Type == MealType.MorningSnack).ToList();
		public List<MealItemViewModel> LunchMeals => Meals?.Where(m => m.Type == MealType.Lunch).ToList();
		public List<MealItemViewModel> SnackMeals => Meals?.Where(m => m.Type == MealType.Snack).ToList();
		public List<MealItemViewModel> SupperMeals => Meals?.Where(m => m.Type == MealType.Supper).ToList();

		public bool ShowBreakfast => BreakfastMeals?.Count != 0 && BreakfastMeals != null;
		public bool ShowMorningSnack => MorningSnackMeals?.Count != 0 && MorningSnackMeals != null;
		public bool ShowLunch => LunchMeals?.Count != 0 && LunchMeals != null;
		public bool ShowSnack => SnackMeals?.Count != 0 && SnackMeals != null;
		public bool ShowSupper => SupperMeals?.Count != 0 && SupperMeals != null;

		private List<MealItemViewModel> Meals;

		public string Date { get; set; }

		public MenuDateViewModel(List<Meal> meals, DateTime date)
		{
			this.Date = date.ToShortDateString();
			OnPropertyChanged(nameof(Date));
			Meals = new List<MealItemViewModel>();
			foreach (var meal in meals)
			{
				Meals.Add(new MealItemViewModel()
				{
					Type = meal.Type,
					Text = meal.Text
				});
			}
		}
	}
}