﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Models;
using Skeleton.Mobile.ODM.Models.Events;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.ViewModels.ComponentViewModels
{
	public class MultiSelectViewViewModel : CancellationViewModel
	{
		public delegate void MultiSelectChangedEventHandler(object sender, MultiSelectChangedEventArgs args);

		public event MultiSelectChangedEventHandler MultiSelectChanged;

		public MultiSelectViewViewModel(List<string> items, List<bool> selectedIndexes)
		{
			this.list = new ObservableCollection<MultiSelectItem>();
			for (int i = 0; i < items.Count; i++)
			{
				this.list.Add(new MultiSelectItem()
				{
					DisplayName = items[i],
					Index = i
				});
				this.list[i].IsSelected = i < selectedIndexes.Count && selectedIndexes[i];
			}
		}

		public void ListItemClicked(int index)
		{
			this.List[index] = new MultiSelectItem()
			{
				DisplayName = this.List[index].DisplayName,
				IsSelected = !this.List[index].IsSelected,
				Index = this.List[index].Index
			};

			this.MultiSelectChanged?.Invoke(this, new MultiSelectChangedEventArgs(List.ToList()));
		}


		private ObservableCollection<MultiSelectItem> list;

		public ObservableCollection<MultiSelectItem> List
		{
			get => this.list;
			set { this.list = value; this.OnPropertyChanged(); }
		}
	}
}
