﻿using Skeleton.Mobile.Framework.Data.Configuration;
using Skeleton.Mobile.ODM.Backend.Configuration;
using Skeleton.Mobile.ODM.Tools;

namespace Skeleton.Mobile.ODM.ViewModels
{
	class ErrorReportViewModel : Framework.Error.Forms.ErrorReport.ErrorReportViewModel
	{
		protected override string ReportSuccessfullySendedMessage => "ErrorReport_SuccessMessage".LocalizeResx();
		protected override string ReportSuccessfullySendedTitle => "ErrorReport_SuccessTitle".LocalizeResx();
		protected override string SendingReportString => "ErrorReport_Loading".LocalizeResx();
		protected override string ReportUnsuccessfullySendedTitle => "ErrorReport_UnsuccessTitle".LocalizeResx();
		protected override string ReportUnsuccessfullySendedMessage => "ErrorReport_UnsuccessMessage".LocalizeResx();
		protected override string InputNotValidTitle => "ErrorReport_InputNotValidTitle".LocalizeResx();
		protected override string InputNotValidMessage => "ErrorReport_InputNotValidMessage".LocalizeResx();

		public string LogCheckBoxText
		{
			get
			{
				return $"{"ErrorReport_AttachLog".LocalizeResx()}{this.LogSize}";
			}
		}

		public string DatabaseCheckBoxText
		{
			get
			{
				return $"{"ErrorReport_AttachDatabase".LocalizeResx()}{this.DatabaseSize}";
			}
		}

		public override AbsConfigurationFactory ConfigurationFactory => new ODMConfigurationFactory();
	}
}
