﻿using System.Collections.Generic;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Backend.Managers;
using Skeleton.Mobile.ODM.Tools;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class FoodMenuRootViewModel : CancellationViewModel
	{
		public List<Menu> Menus { get; set; }

		protected override async Task<bool> LoadDataInternal()
		{
			var foodManager = new FoodManager();

			using (var managerAssistant = new ManagerAssistant(this, foodManager, "FoodMenuRootvm_LoadingFood".LocalizeResx()))
			{
				this.Menus = await foodManager.GetMenus();
			}

			return await base.LoadDataInternal();	
		}
	}
}