﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Backend.Managers;
using Skeleton.Mobile.ODM.Tools;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class FoodMenuViewModel : CancellationViewModel
	{
		public Menu Menu { get; set; }

		private List<Meal> meals;

		public List<Meal> Meals
		{
			get { return meals; }
			set { meals = value; OnPropertyChanged(); }
		}

		public List<DateTime> Dates { get; set; }

		public FoodMenuViewModel(Menu menu)
		{
			this.Menu = menu;
		}

		protected override async Task<bool> LoadDataInternal()
		{
			var foodManager = new FoodManager();

			using (var managerAssistant = new ManagerAssistant(this, foodManager, "FoodMenuVm_LoadingFood".LocalizeResx()))
			{
				this.Meals = await foodManager.GetMealsByMenu(this.Menu);
			}
			Dates = new List<DateTime>();
			foreach (var meal in this.Meals)
			{
				if (!Dates.Contains(meal.Date))
				{
					Dates.Add(meal.Date);
				}
			}
			Dates.Sort();

			return await base.LoadDataInternal();
		}
	}
}