﻿using System;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Backend.Enums;

namespace Skeleton.Mobile.ODM.ViewModels.ItemViewModels
{
	public class MenuItemViewModel : ViewModel
	{
		/// <summary>
		/// Popisek položky menu
		/// </summary>
		public string Title { get; set; }

		/// <summary>
		/// Ikona položky menu
		/// </summary>
		public string Icon { get; set; }

		/// <summary>
		/// FontFamily ikonky položky menu
		/// </summary>
		public string FontFamily { get; set; }

		/// <summary>
		/// Stránka, na kterou se má přesměrovat
		/// Pokud je null, využije se vlastnost Click
		/// </summary>
		public Type TargetType { get; set; }

		/// <summary>
		/// Akce, která se má při kliknutí na položku menu vykonat
		/// Vykoná se pouze, pokud je vlastnost TargetType null
		/// </summary>
		public Action Click { get; set; }

		/// <summary>
		/// Pokud je true, nastaví se položce horní oddělovač   
		/// </summary>
		public bool UpperSeparator { get; set; }

		/// <summary>
		/// Dodatečná data položky
		/// </summary>
		public object Data { get; set; }

		/// <summary>
		/// Pořadí položky v menu
		/// </summary>
		public int Order { get; set; }

		/// <summary>
		/// Udava, zdali je položka vybraná v list
		/// </summary>
		private bool selected;
		public bool Selected
		{
			get
			{
				return this.selected;
			}
			set
			{
				if (this.selected != value)
				{
					this.selected = value;
					this.OnPropertyChanged();
				}
			}
		}

		/// <summary>
		/// ItemType položky, určeno pro filtrování
		/// </summary>
		public MenuItemType ItemType { get; set; }


		/// <summary>
		/// Barva pro dlaždici na home page
		/// </summary>
		//public Color Color { get; set; }
	}
}
