﻿using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWebService.DL.Entities.Enums;

namespace Skeleton.Mobile.ODM.ViewModels.ItemViewModels
{
	public class ResultItemViewModel
	{
		public Region Region { get; set; }
		public bool HasCompetitorName => Competitor == null;

		public ResultItemViewModel(CompetitionResult result, Region region)
		{
			Competitor = result.Competitor;
			Points = result.Points.ToString();
			RegionId = result.RegionId;
			Region = region;
		}

		public ResultItemViewModel(EventResult result, Region region)
		{
			Competitor = result.Competitor;
			Points = result.Points;
			RegionId = result.RegionId;
			Region = region;
		}

		public Gender Gender { get; set; }
		public string Race { get; set; }
		public string Competitor { get; set; }
		public string Points { get; set; }
		public int? RegionId { get; set; }
	}
}