﻿using System;
using System.Windows.Input;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.ViewModels.ItemViewModels
{
	public class TileItemViewModel
	{
		public ICommand tileCommand { get; set; }

		public string Title { get; set; }

		public string Key { get; set; }

		/// <summary>
		/// Jako obrázek se použije iconImage
		/// </summary>
		public TileItemViewModel(string fontFamily, string Icon, string title, Action command, Color color) : this(title, command, color)
		{
			this.IconImage = true;
			this.FontFamily = fontFamily;
			this.Icon = Icon;
		}

		/// <summary>
		/// Jako obrázek se použije obrázek z resources
		/// </summary>
		public TileItemViewModel(string title, Action command, string key, Color color) : this(title, command, color)
		{
			this.Key = key;
			this.IconImage = false;
		}

		private TileItemViewModel(string title, Action command, Color color)
		{
			this.Title = title;
			this.tileCommand = new Command(command);
			this.Color = color;
		}

		/// <summary>
		/// Barva pro dlaždici na home page
		/// </summary>
		public Color? Color { get; set; }

		/// <summary>
		/// true = jako obrázek se použije ikonka
		/// false = jako obrázek se použije obrázek z Resources
		/// </summary>
		public bool IconImage { get; set; }
		
		#region IconImage

		/// <summary>
		/// Využije se pouze pokud je IconImage true
		/// </summary>
		public string FontFamily { get; set; }

		/// <summary>
		/// kód ikonky
		/// </summary>
		public string Icon { get; set; }


		#endregion

		#region ResourcesImage

		/// <summary>
		/// Sport má Key hodnotu, obrázky sportů jsou pojmenované stejně
		/// </summary>
		public string Source => Key + ".png";

		#endregion
	}
}