﻿using System.Collections.Generic;
using System.Windows.Input;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Models.Events;
using Skeleton.Mobile.ODM.Views;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class MessageListFilterViewModel : ViewModel
	{
		private List<MessageTopicEnum> items = new List<MessageTopicEnum>();
		public event MessageListFilterPage.MessageTopicChangedEventHandler MessageTopicChanged;

		public List<MessageTopicEnum> Items => items;

		public MessageListFilterViewModel()
		{
			Items.Add(MessageTopicEnum.Announcement);
			Items.Add(MessageTopicEnum.Invitation);
			Items.Add(MessageTopicEnum.ProgramChange);
			Items.Add(MessageTopicEnum.TransportChange);
			Items.Add(MessageTopicEnum.Update);
		}

		public bool WasSelected { get; set; } = false;

		public MessageTopicEnum SelectedItem
		{
			get { return MessageTopicEnum.NoTopic; }
			set
			{
				if (value != null)
				{
					if (WasSelected)
					{
						//hodnota se schvalne neuklada
						MessageTopicChanged?.Invoke(this, new MessageTopicChangedEventArgs(value));
						OnPropertyChanged();
						RootPage.RootNavigationPage.PopAsync();
						this.WasSelected = false;
					}

				}
			}
		}
	}
}