﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ComponentViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class MyCalendarPageViewModel : ViewModel
	{
		public string Title { get; set; }

		public EventCalendarViewModel CalendarViewModel { get; set; }

		public MyCalendarPageViewModel(List<EventItemCalendarViewModel> events, DateTime date)
		{
			CultureInfo csCZ = new CultureInfo("cs-CZ");
			Title = date.ToString("dddd", csCZ) + "\n" + date.ToString("d", csCZ);
			this.CalendarViewModel = new EventCalendarViewModel(events.OrderBy(e => e.Start).ToList());
		}

	}
}