﻿using System;
using System.Collections.Generic;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Models.Events;
using Skeleton.Mobile.ODM.Views;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class VenueListFilterByCityViewModel : CancellationViewModel
	{
		public List<string> Cities { get; private set; }

		public VenueListFilterByCityViewModel(List<string> cities)
		{
			this.Cities = cities;
		}

		public delegate void VenueCityChangedEventHandler(object sender, VenueCityChangedEventArgs args);

		public event VenueListFilterRootPage.VenueCityChangedEventHandler VenueCityChanged;

		public bool WasSelected { get; set; } = false;

		public string SelectedItem
		{
			get { return String.Empty ; }
			set
			{
				if (value != null)
				{
					if (WasSelected)
					{
						//hodnota se schvalne neuklada
						VenueCityChanged?.Invoke(this, new VenueCityChangedEventArgs(value));
						OnPropertyChanged();
						RootPage.RootNavigationPage.PopAsync();
						this.WasSelected = false;
					}

				}
			}
		}
	}
}