﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using ODM.Backend.Models.Enums;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Models.Events;
using Skeleton.Mobile.ODM.Views;

namespace Skeleton.Mobile.ODM.ViewModels
{
	class VenueListFilterByTypeViewModel : CancellationViewModel
	{
		private readonly List<VenueTypeEnum> items = new List<VenueTypeEnum>();

		public List<VenueTypeEnum> Items => items;

		public event VenueListFilterRootPage.VenueTypeChangedEventHandler VenueTypeChanged;

		public VenueListFilterByTypeViewModel()
		{
			Items.Add(VenueTypeEnum.Sport);
			Items.Add(VenueTypeEnum.Canteen);
			Items.Add(VenueTypeEnum.Housing);
		}

		#region Properties

		public bool WasSelected { get; set; } = false;

		public VenueTypeEnum SelectedItem
		{
			get { return VenueTypeEnum.Unspecified; }
			set
			{
				if (value != null)
				{
					if (WasSelected)
					{
						//hodnota se schvalne neuklada
						VenueTypeChanged?.Invoke(this, new VenueTypeChangedEventArgs(value));
						OnPropertyChanged();
						RootPage.RootNavigationPage.PopAsync();
						this.WasSelected = false;
					}
				}
			}
		}

		#endregion
	}
}
