﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Backend.Managers;
using Skeleton.Mobile.ODM.Tools;

namespace Skeleton.Mobile.ODM.ViewModels
{
	public class VenueListFilterRootPageViewModel : CancellationViewModel
	{
		public List<string> Cities { get; private set; } = null;

		protected override async Task<bool> LoadDataInternal()
		{
			await base.LoadDataInternal();

			VenueManager vManager = new VenueManager();
			using (var managerAssistant = new ManagerAssistant(this, vManager, String.Empty, false))
			{
				Cities = await vManager.GetCities();
			}

			this.SetBackgroundWorking(false);

			return Cities != null;
		}
	}
}