﻿using Rg.Plugins.Popup.Pages;
using Rg.Plugins.Popup.Services;
using Skeleton.Mobile.Framework.Controls.Forms.ProgressIndication;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Xamarin.Forms;

namespace Skeleton.Mobile.ODM.Views.Abstract
{
	public class ODMPage : BackgroundWorkingPage
	{
		protected bool newPageClicked;

		public ODMPage()
		{
			this.newPageClicked = false;
			this.BackgroundColor = (Color)App.Current.Resources["PrimaryBackgroundColor"];
		}

		protected override void OnDisappearing()
		{
			base.OnDisappearing();
			if (this.BindingContext is CancellationViewModel)
			{
				(this.BindingContext as CancellationViewModel).Cancel();
			}
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			if (this.BindingContext is CancellationViewModel)
			{
				await (this.BindingContext as CancellationViewModel).CheckAndRefreshCanceledOperations();
			}
		}

		/// <summary>
		/// slouzi k bezpecnemu presmerovani na stranku, napriklad z listview, kdy se muze vyvolat dvakrat za sebou
		/// </summary>
		/// <param name="page"></param>
		public static void SafeGoToPage(Page page)
		{
			var stack = RootPage.RootNavigationPage.Navigation.NavigationStack;
			if (stack[stack.Count - 1].GetType() != page.GetType())
			{
				RootPage.RootNavigationPage.PushAsync(page);
			}
		}
		/// <summary>
		/// viz. SafeGoToPage, jen pro Popup stránky
		/// </summary>
		/// <param name="page"></param>
		public static void SafeGoToPopupPage(PopupPage page)
		{
			var stack = PopupNavigation.Instance.PopupStack;

			if (stack.Count != 0)
			{
				if (stack[stack.Count - 1].GetType() != page.GetType())
				{
					PopupNavigation.Instance.PushAsync(page);
				}
			}
			else
			{
				PopupNavigation.Instance.PushAsync(page);
			}
		}
	}
}
