﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Rg.Plugins.Popup.Pages;
using Rg.Plugins.Popup.Services;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class CompetitionDetailPage : PopupPage
	{
		private CompetitionDetailViewModel vm;
		public CompetitionDetailPage (CompetitionDetailViewModel vm)
		{
			InitializeComponent ();
			this.vm = vm;
			this.BindingContext = this.vm;
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			await vm.LoadData();
			vm.LoadEventsAreInCalendar();

			GenerateButtons();
		}

		protected void GenerateButtons()
		{
			for (var i = 0; i < vm.Dates.Count; i++)
			{
				Button dateButton = new Button();
				dateButton.Command = vm.ChangeDateCommand;
				dateButton.CommandParameter = vm.Dates[i];
				CultureInfo csCZ = new CultureInfo("cs-CZ");
				dateButton.Text = vm.Dates[i].ToString("dddd", csCZ) + "\n" + vm.Dates[i].ToString("d", csCZ);

				DateButtons.Children.Add(dateButton);
			}

			
		}
	}
}