﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.Pages;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Skeleton.Mobile.ODM.Views.CustomViews;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class CompetitionListPage : ODMPage
	{
		private CompetitionListViewModel vM;
		private Task loadingTask;

		public CompetitionListPage(Sport sport)
		{
			InitializeComponent();

			this.vM = new CompetitionListViewModel(sport);
			this.BindingContext = vM;
		}

		public CompetitionListPage(List<CompetitionItemViewModel> comps)
		{
			InitializeComponent();
			this.vM = new CompetitionListViewModel(comps);
			this.BindingContext = this.vM;
		}

		public override async Task OnPageLoaded()
		{
			await base.OnPageLoaded();
			loadingTask = this.vM.LoadData();
		}

		protected override async void OnAppearing()
		{ 
			base.OnAppearing();
			await this.loadingTask;
		}
	}
}