﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels.ComponentViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.CustomViews;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views.Components
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MenuDateView : ContentView
	{
		private MenuDateViewModel vm;
		public MenuDateView (MenuDateViewModel vm)
		{
			InitializeComponent();
			this.vm = vm;
			this.BindingContext = vm;

			if (vm.ShowBreakfast)
			{
				var breakfast = DrawMeal("Food_Breakfast", vm.BreakfastMeals);
				this.Menu.Children.Add(breakfast);
			}

			if (vm.ShowMorningSnack)
			{
				var morningSnack = DrawMeal("Food_MorningSnack", vm.MorningSnackMeals);
				this.Menu.Children.Add(morningSnack);
			}

			if (vm.ShowLunch)
			{
				var lunch = DrawMeal("Food_Lunch", vm.LunchMeals);
				this.Menu.Children.Add(lunch);
			}

			if (vm.ShowSnack)
			{
				var snack = DrawMeal("Food_Snack", vm.SnackMeals);
				this.Menu.Children.Add(snack);
			}

			if (vm.ShowSupper)
			{
				var supper = DrawMeal("Food_Supper", vm.SupperMeals);
				this.Menu.Children.Add(supper);
			}
		}


		private MenuCourseItemView DrawMeal(string courseLabelName, List<MealItemViewModel> meals)
		{
			var menu = new MenuCourseItemView(courseLabelName, meals);
			return menu;
		}
	}
}