﻿using System;
using System.Collections.Generic;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views.CustomViews
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MenuCourseItemView : ContentView
	{
		public MenuCourseItemView (string name, List<MealItemViewModel> meals)
		{
			InitializeComponent ();
			DrawLayout(name, meals);
		}

		private void DrawLayout(string name, List<MealItemViewModel> meals){
			var lbl = new Label()
			{
				Text = name.LocalizeResx(),
				Margin = new Thickness() { Top = Double.Parse(App.Current.Resources["DefaultMarginValue"].ToString()), Left = Double.Parse(App.Current.Resources["DefaultMarginHalfValue"].ToString()),
				}
			};
			lbl.FontAttributes = FontAttributes.Bold;
			this.Layout.Children.Add(lbl);

			lbl.Margin = new Thickness() { Top = Double.Parse(App.Current.Resources["DefaultMarginValue"].ToString()), Left = Double.Parse(App.Current.Resources["DefaultMarginHalfValue"].ToString()) };

			foreach (var meal in meals)
			{
				var mealLbl = new Label() {
					Text = meal.Text,
				};
				mealLbl.Margin = new Thickness() { Left = Double.Parse(App.Current.Resources["DefaultMarginHalfValue"].ToString()) };
				this.Layout.Children.Add(mealLbl);
			}
		}

	}
}