﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.ODM.Converters;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views.CustomViews
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MessageItemView : ContentView
	{
		private MessageItemViewModel model;
		public MessageItemView()
		{
			InitializeComponent();
		}

		protected override void OnBindingContextChanged()
		{
			base.OnBindingContextChanged();
			if (model == null && this.BindingContext.GetType() == typeof(MessageItemViewModel))
			{
				this.model = (MessageItemViewModel)this.BindingContext;

				CreateColorColumn();
			}
		}

		private void CreateColorColumn()
		{
			BoxView colorColumn = new BoxView()
			{
				WidthRequest = 5,
				Margin = new Thickness() { Left = (Double)App.Current.Resources["DefaultMarginHalfValue"] },
				VerticalOptions = LayoutOptions.FillAndExpand
			};
			colorColumn.SetValue(Grid.ColumnProperty, 2);
			colorColumn.SetValue(Grid.RowProperty, 0);
			colorColumn.SetValue(Grid.RowSpanProperty, 3);

			var converter = new MessageTopicToColorConverter();
			Color columnColor = (Color)converter.Convert(this.model.Topic, null, null, null);
			colorColumn.Color = columnColor;

			this.ItemGrid.Children.Add(colorColumn);
		}

	}
}