﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Rg.Plugins.Popup.Pages;
using Skeleton.Mobile.ODM.ViewModels;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class EventResultPopupPage : PopupPage
	{
		private EventResultPopupPageViewModel vM;
		public EventResultPopupPage(Event ev, Competition comp)
		{
			InitializeComponent();
			this.vM = new EventResultPopupPageViewModel(ev, comp);
			this.BindingContext = this.vM;
		}

		protected override async void OnAppearing()
		{
			await vM.LoadData();

			base.OnAppearing();

			DrawResults();
		}

		private void DrawResults()
		{
			var table = this.ResultsTable;

			for (var i = 0; i < this.vM.ResultViewModels.Count; i++)
			{
				var result = this.vM.ResultViewModels[i];
				int row = i + 2;

				table.RowDefinitions.Add(new RowDefinition() { Height = GridLength.Auto });

				Label rank = new Label() { Text = $"{i + 1}.", HorizontalTextAlignment = TextAlignment.Center };
				Label name = new Label() { Text = $"{result.Competitor}", HorizontalTextAlignment = TextAlignment.Center };
				Label region = new Label() { Text = $"{result.Region?.Name}", HorizontalTextAlignment = TextAlignment.Center };
				Label points = new Label() { Text = $"{result.Points}", HorizontalTextAlignment = TextAlignment.Center };

				rank.SetValue(Grid.ColumnProperty, 0);
				name.SetValue(Grid.ColumnProperty, 1);
				region.SetValue(Grid.ColumnProperty, 2);
				points.SetValue(Grid.ColumnProperty, 3);

				rank.SetValue(Grid.RowProperty, row);
				name.SetValue(Grid.RowProperty, row);
				region.SetValue(Grid.RowProperty, row);
				points.SetValue(Grid.RowProperty, row);

				table.Children.Add(rank);
				table.Children.Add(name);
				table.Children.Add(region);
				table.Children.Add(points);
			}
		}
	}
}