﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ComponentViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Skeleton.Mobile.ODM.Views.Components;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class FoodMenuPage : ODMPage
	{
		private FoodMenuViewModel vm;
		public FoodMenuPage(FoodMenuViewModel vm)
		{
			InitializeComponent ();
			this.Title = vm.Menu.Name;
			this.vm = vm;
		}

		private List<MenuDateView> menuViews = new List<MenuDateView>();

		private Task<bool> loadinTask;

		public override Task OnPageLoaded()
		{
			this.loadinTask = vm.LoadData();
			return base.OnPageLoaded();
		}

		private bool draw = false;

		protected override async void OnAppearing()
		{ 
			base.OnAppearing();
			await loadinTask;
			if (draw == false)
			{
				foreach (var dateTime in vm.Dates)
				{
					var menuview =
						new MenuDateView(new MenuDateViewModel(this.vm.Meals.Where(m => m.Date == dateTime).ToList(),
							dateTime));
					menuViews.Add(menuview);
					Menus.Children.Add(menuview);
				}
				
				draw = true;
			}
			
		}


	}
}