﻿using System;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Inputs;
using Skeleton.Mobile.Framework.Controls.Forms.Pages;
using Skeleton.Mobile.ODM.Backend.Managers;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.Abstract;
using Skeleton.Mobile.ODM.Views;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class HomePage : ODMPage
	{
		private HomeViewModel vM;
		public HomePage()
		{
			InitializeComponent();
			this.Title = "ApplicationName".LocalizeResx();
			vM = new HomeViewModel();
			this.BindingContext = vM;
		}

		private Task loadingTask;

		public override async Task OnPageLoaded()
		{
			await base.OnPageLoaded();
			this.loadingTask = vM.LoadData();
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			await loadingTask;
		}


	}
}
