﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODMWebService.DL.Entities.Enums;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.Abstract;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MainProgramRootPage : TilesPage
	{
		public MainProgramRootPage()
		{
			InitializeComponent();
			this.Title = "MainProgramRootPage_Title".LocalizeResx();
			var viewModel = new MainProgramRootPageViewModel();
			viewModel.TileItems = new List<TileItemViewModel>()
			{
				new TileItemViewModel(
					fontFamily:"FontAwesome5FreeSolid",
					Icon: "\uf073",
					title: "MainProgramRootPage_Calendar".LocalizeResx(),
					command:(() => { SafeGoToPage(new MyCalendarRootPage()); }),
					color: Color.Blue
				),
				new TileItemViewModel(
					fontFamily:"FontAwesome5FreeSolid",
					Icon: "\uf436",
					title: "MainProgramRootPage_BySport".LocalizeResx(),
					command:(() => { SafeGoToPage(new ProgramBySportsRootPage());}),
					color: Color.Chartreuse
				),
				new TileItemViewModel(
					title: "MainProgramRootPage_ByCity".LocalizeResx(),
					fontFamily:"FontAwesome5FreeSolid",
					Icon:"\uf64f",
					command:(() => { SafeGoToPage(new ProgramByCityPage()); }),
					color: Color.DeepPink
				),
				new TileItemViewModel(
					title: "MainProgramRootPage_Ceremonials".LocalizeResx(),
					fontFamily:"FontAwesome5FreeSolid",
					Icon:"\uf64f",
					command:(() => { SafeGoToPage(new SideProgrammePage(CompetitionTypeEnum.Ceremonial));}),
					color: Color.CadetBlue
				),
				new TileItemViewModel(
					title: "MainProgramRootPage_Entertainment".LocalizeResx(),
					fontFamily:"FontAwesome5FreeSolid",
					Icon:"\uf64f",
					command:(() => { SafeGoToPage(new SideProgrammePage(CompetitionTypeEnum.Entertainment)); }),
					color: Color.DarkGoldenrod
				),
			};
			base.viewModel = viewModel;
			BindingContext = base.viewModel;

			base.Initialize(this.rootScrollView, this.HidingView, this.TilesGrid);
		}
	}
}