﻿using System;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MenuPage : ODMPage
	{
		private MenuViewModel viewModel;

		/// <summary>
		/// Event co se vyvolá při vybrání prvku.
		/// </summary>
		public event EventHandler<SelectedItemChangedEventArgs> ItemSelected;

		private void OnItemSelected(object sender, SelectedItemChangedEventArgs e)
		{
			this.ItemSelected?.Invoke(this, e);
		}

		public MenuPage()
		{
			InitializeComponent();
			this.viewModel = new MenuViewModel();
			this.BindingContext = this.viewModel;
			(this.BindingContext as MenuViewModel).PropertyChanged += MenuPage_PropertyChanged;
		}

		private void MenuPage_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
		{
			if (e.PropertyName == "SelectedItem")
			{
				OnItemSelected(this, new SelectedItemChangedEventArgs((sender as MenuViewModel).SelectedItem));
			}
		}

		public void MarkItemAsSelected(Type targetType)
		{
			this.viewModel.MarkItemAsSelected(targetType);
		}
	}
}