﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.ODM.Models.Events;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MessageListFilterPage : ODMPage
	{
		private MessageListFilterViewModel vm;
		public MessageListFilterPage ()
		{
			InitializeComponent ();
			this.vm = new MessageListFilterViewModel();
			vm.MessageTopicChanged += Filter_MessageTopicChanged;
			this.BindingContext = this.vm;
		}

		public override Task OnPageLoaded()
		{
			vm.WasSelected = true;
			return base.OnPageLoaded();
		}

		public delegate void MessageTopicChangedEventHandler(object sender, MessageTopicChangedEventArgs args);

		public event MessageTopicChangedEventHandler MessageTopicChanged;

		public void Filter_MessageTopicChanged(object sender, MessageTopicChangedEventArgs args)
		{
			MessageTopicChanged?.Invoke(sender, args);
		}
	}
}