﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Pages;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ComponentViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Skeleton.Mobile.ODM.Views.Components;
using Skeleton.Mobile.ODM.Views.CustomViews;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MyCalendarPage : ODMPage
	{
		private MyCalendarPageViewModel vm;
		private EventCalendarView calendarView;
		public MyCalendarPage(List<EventItemCalendarViewModel> events, DateTime date)
		{
			InitializeComponent();
			this.vm = new MyCalendarPageViewModel(events, date);
			this.BindingContext = this.vm;
			this.Title = vm.Title;
			this.calendarView = new EventCalendarView(this.vm.CalendarViewModel);
			this.CalendarPlaceholder.Content = this.calendarView;
		}

		private Grid grid;

		protected override void OnViewLoad(double width, double height, OrientationMode orientation)
		{
			base.OnViewLoad(width, height, orientation);
			this.calendarView.CreateCalendar();
		}
	}
}