﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Inputs;
using Skeleton.Mobile.Framework.Controls.Forms.Pages.TabPageLoading;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class MyCalendarRootPage : AbsLoadingTabPage
	{
		private MyCalendarRootViewModel vm;
		public MyCalendarRootPage()
		{
			InitializeComponent();
			this.Title = "MainProgramRootPage_Calendar".LocalizeResx();
		}

		public override void OnDataLoaded()
		{
		}

		protected override List<Page> GetPages()
		{
			List<Page> output = new List<Page>();

			foreach (var dateTime in this.vm.Dates)
			{
				List<EventItemCalendarViewModel> events =
					this.vm.CalendarEvents.Where(c => c.Start.Date == dateTime.Date).ToList();

				var page = new MyCalendarPage(events, dateTime);
				output.Add(page);
			}

			if (output.Count == 0)
			{
				var page = new ContentPage();
				var content = new StackLayout();

				content.HorizontalOptions = LayoutOptions.FillAndExpand;
				content.VerticalOptions = LayoutOptions.Center;

				var emptyLabel = new Label() { HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, Text = "MyCalendarRootPage_Empty".LocalizeResx(), VerticalOptions = LayoutOptions.Center, HorizontalOptions = LayoutOptions.Center, Margin = new Thickness() { Left = (double)App.Current.Resources["DefaultMarginValue"], Right = (double)App.Current.Resources["DefaultMarginValue"] } };

				var iconLabel = new IconLabel() { Text = App.Current.Resources["CalendarPlusIcon"].ToString(), HorizontalOptions = LayoutOptions.Center, FontFamily = "FontAwesome5FreeRegular" };

				var calLabel = new Label() { HorizontalTextAlignment = TextAlignment.Center, VerticalTextAlignment = TextAlignment.Center, Text = "MyCalendarRootPage_Cal".LocalizeResx(), VerticalOptions = LayoutOptions.Center, HorizontalOptions = LayoutOptions.Center, Margin = new Thickness() { Left = (double)App.Current.Resources["DefaultMarginValue"], Right = (double)App.Current.Resources["DefaultMarginValue"] } };


				content.Children.Add(emptyLabel);
				content.Children.Add(iconLabel);
				content.Children.Add(calLabel);

				page.Content = content;
				output.Add(page);
			}

			return output;
		}

		protected override CancellationViewModel CreateLoadingViewModel()
		{
			this.vm = new MyCalendarRootViewModel();
			return this.vm;
		}
	}
}