﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Inputs;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Skeleton.Mobile.ODM.Views.CustomViews;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class NavigateHomePage : ODMPage
	{
		private NavigateHomeViewModel vM;

		private Color RoundButtonColor = (Color) App.Current.Resources["YellowColor"];

		private IconLabel icon;

		public NavigateHomePage ()
		{
			InitializeComponent ();
			this.vM = new NavigateHomeViewModel();
			this.BindingContext = this.vM;

			var button = new ContentButton()
			{
				HeightRequest = 200,
				WidthRequest = 200,
				BackgroundColor = RoundButtonColor,
				Margin = new Thickness(0),
				Command = vM.NavigateCommand,
			};

			icon = new IconLabel
			{
				FontFamily = (string)App.Current.Resources["FontAwesomeSolid"],
				FontName = "",
				Text = vM.Icon,
				FontSize = (double)App.Current.Resources["NavIcon"],
				HorizontalOptions = new LayoutOptions(LayoutAlignment.Center, false),
				TextColor = Color.White,
			};

			var panel = new StackLayout
			{
				Spacing = 0,
				VerticalOptions = new LayoutOptions(LayoutAlignment.Center, false),
				HorizontalOptions = new LayoutOptions(LayoutAlignment.Center, false)
			};
			panel.Children.Add(icon);

			button.Content = panel;

			this.ButtonFrame.Content = button;
			this.ButtonFrame.BackgroundColor = RoundButtonColor;

			vM.Clicked += ChangeButtonIcon;
		}

		public void ChangeButtonIcon()
		{
			icon.Text = vM.LocationSet ? "\uf015" : "\uf3c5";
		}
	}
}