﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels.Abstract;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class OdmNavigationPage : TilesPage
	{
		public OdmNavigationPage()
		{
			InitializeComponent();
			this.Title = "ODMNavigationPage_Title".LocalizeResx();

			var vM = new TilesViewModel();
			vM.TileItems = new List<TileItemViewModel>()
			{
				new TileItemViewModel( 
					fontFamily:"FontAwesome5FreeSolid",
					Icon: "\uf279",
					title: "Menu_Map".LocalizeResx(),
					command:(() => SafeGoToPage(new MapPage())),
					color: Color.DarkOrange
					),
				new TileItemViewModel(
					fontFamily:"FontAwesome5FreeSolid",
					Icon: "\uf015",
					title: "ODMNavigationPage_GoHome".LocalizeResx(),
					command:(() => SafeGoToPage(new NavigateHomePage())),
					color: Color.DarkRed
				),
				new TileItemViewModel(
					title: "ODMNavigationPage_Places".LocalizeResx(),
					fontFamily:"FontAwesome5FreeSolid",
					Icon:"\uf0ca",
					command:(() => SafeGoToPage(new VenuesFilterPage())),
					color: Color.Aqua
				),


			};
			base.viewModel = vM;
			BindingContext = viewModel;

			base.Initialize(this.rootScrollView, this.HidingView, this.TilesGrid);
		}

		private void SearchClicked(object sender, EventArgs e)
		{
			ODMPage.SafeGoToPage(new VenueSearchPage());
		}
	}
}