﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.Framework.Controls.Forms.Pages;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.Abstract;
using Skeleton.Mobile.ODM.ViewModels.ItemViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Internals;
using Xamarin.Forms.Xaml;
using Device = Skeleton.Mobile.Framework.Device.Device;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class ProgramBySportsRootPage : TilesPage
	{
		private Task<bool> loadingTask;
		public ProgramBySportsRootPage()
		{
			InitializeComponent();
			this.Title = $"{"MainProgramRootPage_Title".LocalizeResx()} - {"MainProgramRootPage_BySport".LocalizeResx()}";

			viewModel = new ProgramBySportsViewModel();
			this.BindingContext = viewModel;
			base.Initialize(this.rootScrollView, this.HidingView, this.TilesGrid);
		}



		public override async Task OnPageLoaded()
		{
			await base.OnPageLoaded();
			loadingTask = this.viewModel.LoadData();
		}

		protected override void OnViewLoad(double width, double height, OrientationMode orientation)
		{
			base.BaseOnViewLoad(width, height,orientation);
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			await this.loadingTask;
			OrientationMode mode = base.Orientation;
			base.GenerateView(Width, Height,mode);
		}
	}
}
