﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ODMWebService.DL.Entities.Enums;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class SideProgrammePage : ODMPage
	{
		private SideProgrammeViewModel vm;
		public SideProgrammePage (CompetitionTypeEnum type)
		{
			InitializeComponent ();

			if (type == CompetitionTypeEnum.Ceremonial)
			{
				this.Title = "MainProgramRootPage_Ceremonials".LocalizeResx();
			}
			else if (type == CompetitionTypeEnum.Entertainment)
			{
				this.Title = "MainProgramRootPage_Entertainment".LocalizeResx();
			}

			this.vm = new SideProgrammeViewModel(type);
			this.BindingContext = this.vm;
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			await vm.LoadData();
			vm.LoadEventsAreInCalendar();

			GenerateButtons();
		}

		protected void GenerateButtons()
		{
			for (var i = 0; i < vm.Dates.Count; i++)
			{
				Button dateButton = new Button();
				dateButton.Command = vm.ChangeDateCommand;
				dateButton.CommandParameter = vm.Dates[i];
				CultureInfo csCZ = new CultureInfo("cs-CZ");
				dateButton.Text = vm.Dates[i].ToString("dddd", csCZ) + "\n" + vm.Dates[i].ToString("d", csCZ);

				DateButtons.Children.Add(dateButton);
			}


		}
	}
}