﻿using System;
using System.Threading.Tasks;
using ODM.Backend.Models.Models;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class VenueDetailPage : ODMPage
	{
		VenueDetailViewModel viewModel;
		private Task<bool> loadingTask;

		public VenueDetailPage(Venue model)
		{
			InitializeComponent();
			this.viewModel = new VenueDetailViewModel(model);
			this.Title = "VenueDetail_PlaceDetail".LocalizeResx();
			this.BindingContext = this.viewModel;

			if (this.viewModel.ShowNavigation)
			{
				this.ToolbarItems.Add(new ToolbarItem("VenueDetail_Navigate".LocalizeResx(), "ic_navigation.png", new Action(this.viewModel.NavigateClick)));
			}
		}

		public override async Task OnPageLoaded()
		{
			await base.OnPageLoaded();
			loadingTask = this.viewModel.LoadData();
		}

		protected override async void OnAppearing()
		{
			base.OnAppearing();
			await this.loadingTask;
		}
	}
}