﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Pages.TabPageLoading;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Models.Events;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class VenueListFilterRootPage : AbsLoadingTabPage
	{
		private VenueListFilterRootPageViewModel viewModel;

		public VenueListFilterRootPage ()
		{
			InitializeComponent ();
		}

		public delegate void VenueTypeChangedEventHandler(object sender, VenueTypeChangedEventArgs args);

		public event VenueTypeChangedEventHandler VenueTypeChanged;

		public delegate void VenueCityChangedEventHandler(object sender, VenueCityChangedEventArgs args);

		public event VenueCityChangedEventHandler VenueCityChanged;


		public override void OnDataLoaded()
		{
		}

		protected override List<Page> GetPages()
		{
			var output = new List<Page>();

			var filterByTypeVm = new VenueListFilterByTypeViewModel();
			filterByTypeVm.VenueTypeChanged += Filter_VenueTypeChanged;
			var filterByTypePage = new VenueListFilterByTypePage(){BindingContext = filterByTypeVm};
			filterByTypePage.Title = "VenueListFilterRootPage_VenueTypes".LocalizeResx();

			var filterByCityVm = new VenueListFilterByCityViewModel(viewModel.Cities);
			filterByCityVm.VenueCityChanged += Filter_VenueCityChanged;
			var filterByCityPage = new VenueListFilterByCityPage() {BindingContext = filterByCityVm};
			filterByCityPage.Title = "VenueListFilterRootPage_Cities".LocalizeResx();

			output.Add(filterByTypePage);
			output.Add(filterByCityPage);

			return output;
		}

		protected override CancellationViewModel CreateLoadingViewModel()
		{
			this.viewModel = new VenueListFilterRootPageViewModel();
			return this.viewModel;
		}

		private void Filter_VenueTypeChanged(object sender, VenueTypeChangedEventArgs args)
		{
			VenueTypeChanged?.Invoke(sender, args);
		}

		private void Filter_VenueCityChanged(object sender, VenueCityChangedEventArgs args)
		{
			VenueCityChanged?.Invoke(sender, args);
		}

	}
}