﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Skeleton.Mobile.Framework.Controls.Forms.Pages.TabPageLoading;
using Skeleton.Mobile.Framework.Controls.Forms.ViewModels;
using Skeleton.Mobile.ODM.Tools;
using Skeleton.Mobile.ODM.ViewModels;
using Skeleton.Mobile.ODM.ViewModels.ComponentViewModels;
using Skeleton.Mobile.ODM.Views.Abstract;
using Skeleton.Mobile.ODM.Views.Components;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace Skeleton.Mobile.ODM.Views
{
	[XamlCompilation(XamlCompilationOptions.Compile)]
	public partial class VenuesFilterPage : AbsLoadingTabPage
	{
		private VenuesFilterViewModel vM;
		public VenuesFilterPage()
		{
			InitializeComponent();
			this.BindingContext = vM;
		}

		public override void OnDataLoaded()
		{
		}

		protected override List<Page> GetPages()
		{
			var output = new List<Page>();

			var filterByCityvM = vM.CreateCityVm();
			filterByCityvM.MultiSelectChanged += FilterByCityVm_MultiSelectChanged;
			var filterByCityPage = new MultiSelectPage(filterByCityvM);
			filterByCityPage.Title = "VenueListFilterRootPage_Cities".LocalizeResx();

			var filterBySportsVm = vM.CreateSportVm();
			filterBySportsVm.MultiSelectChanged += FilterBySportsVm_MultiSelectChanged;
			var filterBySportsPage = new MultiSelectPage(filterBySportsVm);
			filterBySportsPage.Title = "Sports".LocalizeResx();

			var filterByTypeVm = vM.CreateTypeVm();
			filterByTypeVm.MultiSelectChanged += FilterByTypeVm_MultiSelectChanged;
			var filterByTypePage = new MultiSelectPage(filterByTypeVm);
			filterByTypePage.Title = "VenueType".LocalizeResx();

			output.Add(filterByCityPage);
			output.Add(filterBySportsPage);
			output.Add(filterByTypePage);

			return output;
		}

		private void FilterByTypeVm_MultiSelectChanged(object sender, Models.Events.MultiSelectChangedEventArgs args)
		{
			vM.SelectedTypes = args.Items.Where(i=> i.IsSelected == true).ToList();
		}

		private void FilterBySportsVm_MultiSelectChanged(object sender, Models.Events.MultiSelectChangedEventArgs args)
		{
			vM.SelectedSports = args.Items.Where(i => i.IsSelected == true).ToList();
		}

		private void FilterByCityVm_MultiSelectChanged(object sender, Models.Events.MultiSelectChangedEventArgs args)
		{
			vM.SelectedCities = args.Items.Where(i => i.IsSelected == true).ToList();
		}

		protected override CancellationViewModel CreateLoadingViewModel()
		{
			this.vM = new VenuesFilterViewModel();
			return this.vM;
		}

		private async void ShowList(object sender, EventArgs e)
		{
			await this.vM.ShowOnMap_Execute();
		}
	}
}