﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.ForeignModels;
using ODMWebService.DL.Entities.Enums;

namespace ODMWeb.DL.Entities
{
	public class CompetitionEntity : BaseEntity, ICompetition
	{
		public string Discipline { get; set; }
		public string Race { get; set; }
		public Gender Gender { get; set; }
		public CompetitionTypeEnum CompetitionType { get; set; }
		public int? SportId { get; set; }


		[ForeignKey(nameof(SportId))]
		public virtual SportEntity Sport { get; set; }

		public CompetitionEntity()
		{
			this.CompetitionResults = new HashSet<CompetitionResultEntity>();
			this.Events = new HashSet<EventEntity>();
		}


		public virtual ICollection<EventEntity> Events { get; set; }

		public virtual ICollection<CompetitionResultEntity> CompetitionResults { get; set; }

		public static bool ForeignEq(CompetitionEntity rhs, ForeignCompetition lhs)
		{
			return rhs.Discipline == lhs.Discipline && rhs.Race == lhs.Race;
		}
	}
}