﻿using System.ComponentModel.DataAnnotations.Schema;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.ForeignModels;

namespace ODMWeb.DL.Entities
{
	[Table("CompetitionResults")]
	public class CompetitionResultEntity : BaseEntity, ICompetitionResult
	{
		public int? CompetitionId { get; set; }
		[ForeignKey(nameof(CompetitionId))]
		public virtual CompetitionEntity Competition { get; set; }

		public int? ForeignCompetitionId { get; set; }

		public int? RegionId { get; set; }
		[ForeignKey(nameof(RegionId))]
		public virtual RegionEntity Region { get; set; }

		public string Competitor { get; set; }
		public int Rank { get; set; }
		public int Points { get; set; }

		public static bool ForeignEq(CompetitionResultEntity rhs, ForeignCompetitionResult lhs)
		{
			return rhs.Competitor == lhs.Competitior && rhs.Points == lhs.Points && rhs.Rank == lhs.Rank;
		}
	}
}