﻿using System.ComponentModel.DataAnnotations.Schema;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.ForeignModels;

namespace ODMWeb.DL.Entities
{
	[Table("EventResults")]
	public class EventResultEntity : BaseEntity, IDbItem
	{
		public int? EventId { get; set; }
		[ForeignKey(nameof(EventId))]
		public virtual EventEntity Event { get; set; }

		public int? RegionId { get; set; }
		public string Points { get; set; }

		[ForeignKey(nameof(RegionId))] 
		public virtual RegionEntity Region { get; set; }

		public string Competitor { get; set; }
		public int Rank { get; set; }

		public static bool ForeignEq(EventResultEntity rhs, ForeignEventResult lhs)
		{
			return rhs.Points == lhs.Points && rhs.Competitor == lhs.Competitior && rhs.Rank == lhs.Rank;
		}
	}
}