﻿using System;
using System.ComponentModel.DataAnnotations.Schema;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities.Interfaces;

namespace ODMWeb.DL.Entities
{
	[Table("Meals")]
	public class MealEntity : BaseEntity, IDbItem, ILocalDataLifecycle
	{
		[ForeignKey(nameof(MenuId))]
		public virtual MenuEntity Menu { get; set; }

		public DateTime Date { get; set; }
		public int MenuId { get; set; }
		public string Text { get; set; }
		public MealType Type { get; set; }
		public bool IsApproved { get; set; }
	}
}