﻿using System;
using System.ComponentModel.DataAnnotations.Schema;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities.Interfaces;

namespace ODMWeb.DL.Entities
{
	[Table("Messages")]
	public class MessageEntity : BaseEntity, IMessage, ILocalDataLifecycle
	{
		public DateTime Date { get; set; }
		public string Text { get; set; }
		public string Title { get; set; }
		public bool IsImportant { get; set; }
		public MessageTopicEnum Topic { get; set; }
		public bool IsScheduled { get; set; }
		public bool IsApproved { get; set; }
		public new bool IsSerialized { get; set; }
	}
}