﻿using System;

namespace ODMWeb.DL.Entities.Serialization
{
	public class SerializationRecordEntity
	{
		public int Id { get; set; }

		public int Version { get; set; }
		// static, program, data, message
		public SerializationRecordType Type { get; set; }
		/// <summary>
		/// Path to file
		/// </summary>
		public string FilePath { get; set; }

		public bool IsAvailable { get; set; }

		public DateTime SerializationTime { get; set; }

		public string UserName { get; set; }

		public SerializationRecordEntity(int version, SerializationRecordType type, string filePath, string userName = null)
		{
			Version = version;
			Type = type;
			FilePath = filePath;
			this.SerializationTime = DateTime.Now;
			this.UserName = userName;
		}

		public SerializationRecordEntity()
		{
			
		}
	}
}