﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.ForeignModels;

namespace ODMWeb.DL.Entities
{
	[Table("Sports")]
	public class SportEntity : BaseEntity, ISport
	{
		public SportEntity(int id,string itemId, string name)
		{
			this.Id = id;
			this.Item = new IdItem(itemId, name);
		}

		public SportEntity()
		{
			this.Competitions = new HashSet<CompetitionEntity>();
		}

		public virtual ICollection<CompetitionEntity> Competitions { get; set; }
		public virtual IdItem Item { get; set; }

		public static bool ForeignEq(SportEntity lhs, ForeignSport rhs)
		{
			return lhs.Item?.Name == rhs.Name;
		}
	}
}