﻿using System.Threading.Tasks;
using Microsoft.Net.Http.Headers;
using ODMWeb.DL.Entities;
using ODMWeb.DL.EntityDependencies;
using ODMWeb.DL.Repositories;
using ODMWeb.DL.Repositories.Interfaces;

namespace ODMWeb.DL
{
	public interface IUnitOfWork
	{
		#region Static Data
		IVenueRepository Venues { get; }
		IRepository<MealEntity> Meals { get; }
		IRepository<MenuEntity> Menus { get; }
		IRegionRepository Regions { get; }
		ISportRepository Sports { get; }
		#endregion

		#region Message Data
		IRepository<MessageEntity> Messages { get; }
		#endregion

		#region Program Data
		ICompetitionRepository<CompetitionDependencies> Competitions { get; }
		IEventRepository<EventDependencies> Events { get; }
		#endregion

		#region Result Data
		ICompetitionResultRepository CompetitionResults { get; }
		IEventResultRepository EventResults { get; }
		#endregion

		#region Management

		SerializationRecordRepository SerializedFiles { get; set; }

		#endregion

		Task<int> Save();
	}
}