﻿using System.Collections.Generic;
using System.Threading.Tasks;
using ODMWeb.DL.Entities;
using ODMWeb.DL.Exceptions;
using ODMWeb.DL.ForeignModels;

namespace ODMWeb.DL.Repositories.Interfaces
{
	public interface ICompetitionRepository<E> : IRepository<CompetitionEntity>, IForeign<ForeignCompetition, E> where E :IDependencies
	{
		Task<CompetitionEntity> GetCeremonial();
		Task<CompetitionEntity> GetEntertainment();

		/// <exception cref="SportDependencyNotResolvedException">Competition sport not found in context</exception>
		new Task<int> UpdateFromForeign(List<ForeignCompetition> foreignItems);
	}
}