﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using ODMWeb.DL.Entities;
using ODMWeb.DL.Exceptions;
using ODMWeb.DL.ForeignModels;

namespace ODMWeb.DL.Repositories.Interfaces
{
	public interface IEventRepository<E> : IRepository<EventEntity>, IForeign<ForeignEvent, E> where E : IDependencies
	{
		/// <exception cref="CompetitionDependencyNotResolvedException">Event competition not found in context</exception>
		/// <exception cref="VenueDependencyNotResolvedException">Event venue not found in context</exception>
		/// <exception cref="AggregateException">Event venue and competition not found in context</exception>
		new Task<int> UpdateFromForeign(List<ForeignEvent> foreignList);
	}
}