﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using ODM.Backend.Models.Models;
using ODMWeb.DL.Entities;
using ODMWeb.DL.ForeignModels;
using ODMWeb.DL.Repositories.Interfaces;

namespace ODMWeb.DL.Repositories
{
	internal class SportRepository : Repository<SportEntity>, ISportRepository
	{
		public SportRepository(OdmDbContext dbContext) : base(dbContext)
		{
		}

		public async Task<int> UpdateFromForeign(List<ForeignSport> foreignList)
		{

			foreach (var sport in foreignList)
			{
				await UpdateSingleFromForeign(sport);
			}


			return await dbContext.SaveChangesAsync();
		}

		public async Task<BaseDependencies> UpdateSingleFromForeign(ForeignSport foreignItem)
		{
			var entity = await dbContext.Sports.FirstOrDefaultAsync(r => r.ForeignApiId == foreignItem.ForeignId);

			if (entity is null)
			{
				dbContext.Sports.Add(new SportEntity()
				{
					ForeignApiId = foreignItem.ForeignId,
					Item = new IdItem(foreignItem.Name.ToLower(), foreignItem.Name)
				});
			}
			else
			{
				if (SportEntity.ForeignEq(entity, foreignItem)) return new BaseDependencies() { Result = true };
				entity.Item.Name = foreignItem.Name;
				entity.Item.Key = foreignItem.Name.ToLower();
			}
			return new BaseDependencies(){Result = true};
		}
	}
}