﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using ODMWeb.Models.Log;

namespace ODMWeb.Controllers
{
	[Authorize(Roles = "BenevolentDictatorForLife")]
	public class LogsController : Controller
	{
		public IActionResult Index()
		{
			string[] filePaths = Directory.GetFiles(Directory.GetCurrentDirectory()+ "\\Logs", "*.txt", SearchOption.TopDirectoryOnly);
			List<LogViewModel> logs = new List<LogViewModel>();

			foreach (var filePath in filePaths)
			{
				var info = new System.IO.FileInfo(filePath);
				logs.Add(new LogViewModel(filePath, info));
			}

			return View(logs);
		}
		[HttpGet("logs/Show/{name}")]
		public async Task<string> Show(string name)
		{
			string path = Directory.GetCurrentDirectory()+ "\\Logs\\" + name;
			bool logExists = System.IO.File.Exists(path);

			string output = "";

			if (logExists)
			{
				using(var stream = System.IO.File.Open(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
				using (StreamReader logFileReader = new StreamReader(stream))
				{
					output = await logFileReader.ReadToEndAsync();
				}
			}

			return output;
		}

		[HttpGet("logs/Get/{name}")]
		public async Task<IActionResult> Get(string name)
		{
			string path = Directory.GetCurrentDirectory() + "\\Logs\\" + name;
			bool logExists = System.IO.File.Exists(path);

			if (logExists)
			{
				var memory = new MemoryStream();
				using (var stream = System.IO.File.Open(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
				{
					await stream.CopyToAsync(memory);
				}
				memory.Position = 0;
				return File(memory, "text/plain", name);
			}

			return NotFound();
		}
	}
}