﻿using ODM.Backend.Models.Enums;
using ODMWeb.SharedLocalization;

namespace ODMWeb.Converters
{
	public class MealTypeToTextConverter : IMyConverter<MealType>
	{
		private readonly LocService localizer;

		public MealTypeToTextConverter(LocService localizer)
		{
			this.localizer = localizer;
		}

		public string Convert(MealType mealEnum)
		{
			switch (mealEnum)
			{
				case MealType.Breakfast:
					return localizer.Get("MealType_Breakfast");
				case MealType.MorningSnack:
					return localizer.Get("MealType_MorningSnack");
				case MealType.Lunch:
					return localizer.Get("MealType_Lunch");
				case MealType.Snack:
					return localizer.Get("MealType_Snack");
				case MealType.Supper:
					return localizer.Get("MealType_Supper");

				default:
					return mealEnum.ToString();
			}
		}
	}
}