﻿using System;
using AutoMapper;
using ODM.Backend.Models.Enums;
using ODMWeb.SharedLocalization;

namespace ODMWeb.Converters
{
	public class MessageTopicToTextConverter : IMyConverter<MessageTopicEnum>
	{
		private readonly LocService localizer;

		public MessageTopicToTextConverter(LocService localizer)
		{
			this.localizer = localizer;
		}

		public string Convert(MessageTopicEnum topicEnum)
		{
			switch (topicEnum)
			{
				case MessageTopicEnum.Announcement:
					return localizer.Get("MessageTopic_Announcement");
				case MessageTopicEnum.Invitation:
					return localizer.Get("MessageTopic_Invitation");
				case MessageTopicEnum.NoTopic:
					return localizer.Get("MessageTopic_NoTopic");
				case MessageTopicEnum.ProgramChange:
					return localizer.Get("MessageTopic_ProgramChange");
				case MessageTopicEnum.TransportChange:
					return localizer.Get("MessageTopic_TransportChange");
				case MessageTopicEnum.Update:
					return localizer.Get("MessageTopic_Update");
				default:
					return "NotFound";
			}
		}
	}
}