﻿using ODMWeb.DL.Entities.Serialization;
using ODMWeb.SharedLocalization;

namespace ODMWeb.Converters
{
	public class SerializedFileTypeToNameConverter : IMyConverter<SerializationRecordType>
	{
		private readonly LocService localizer;

		public SerializedFileTypeToNameConverter(LocService localizer)
		{
			this.localizer = localizer;
		}

		public string Convert(SerializationRecordType typeEnum)
		{
			switch (typeEnum)
			{
				case SerializationRecordType.Message:
					return localizer.Get("RecordType_Message");
				case SerializationRecordType.Program:
					return localizer.Get("RecordType_Program");
				case SerializationRecordType.Result:
					return localizer.Get("RecordType_Result");
				case SerializationRecordType.Static:
					return localizer.Get("RecordType_Static");
				default:
					return typeEnum.ToString();
			}
		}
	}
}