﻿using System.IO;
using System.Threading.Tasks;
using AutoMapper;
using Microsoft.AspNetCore.Hosting;
using ODMWeb.Controllers.Api;
using ODMWeb.DL;
using Serilog;

namespace ODMWeb.DataProviding.Publishers
{
	public abstract class AbsDataPublisher
	{
		protected readonly IHostingEnvironment Environment;
		protected readonly IMapper Mapper;
		protected readonly IUnitOfWork UnitOfWork;
		protected readonly string FolderPath;
		protected readonly ILogger Logger = Log.ForContext<PublishOdmDataController>();

		protected AbsDataPublisher(IHostingEnvironment environment, IMapper mapper, IUnitOfWork unitOfWork)
		{
			this.Environment = environment;
			this.Mapper = mapper;
			this.UnitOfWork = unitOfWork;
			this.FolderPath = Path.Combine(this.Environment.ContentRootPath, Config.FolderName);
		}

		public abstract Task<bool> Run(string userName);
	}
}