﻿using System.Threading.Tasks;
using AutoMapper;
using Microsoft.Extensions.Logging;
using ODMWeb.DL;

namespace ODMWeb.DataProviding.Serialization
{
	public interface IDataSerializer<Entity, Data> where Entity : class where Data : class
	{
		Data CreateDataGroup(IMapper mapper, Entity entities);
		Task<Entity> CreateEntityGroup(IUnitOfWork unitOfWork);
		bool SerializeData(Data data, string path, int version, IUnitOfWork unitOfWork = null);
	}
}