﻿using System.Threading.Tasks;
using Hangfire;
using ODMWeb.DL;
using ODMWeb.Hangfire.RecurringJobs;
using Serilog;

namespace ODMWeb.Hangfire
{
	public abstract class BaseHangfireTask<E> where E : class
	{
		protected readonly IUnitOfWork unitOfWork;
		protected readonly ILogger logger = Log.ForContext<E>();

		public BaseHangfireTask(IUnitOfWork unitOfWork)
		{
			this.unitOfWork = unitOfWork;
		}

		public abstract Task Run();
	}
}