﻿using System.Threading.Tasks;
using ODMWeb.DL;
using ODMWeb.ForeignApiManager;
using ODMWeb.Hangfire.RecurringJobs;
using Serilog;

namespace ODMWeb.Hangfire.Jobs
{
	public class UpdateRegionDataTask : BaseHangfireTask<UpdateRegionDataTask>
	{

		public override async Task Run()
		{
			var service = new WebService();
			this.logger.Information("UpdateRegionDataTask start.");
			var data = await service.GetRegions();
			await this.unitOfWork.Regions.UpdateFromForeign(data);
			this.logger.Information("UpdateRegionDataTask successful.");
		}

		public UpdateRegionDataTask(IUnitOfWork unitOfWork) : base(unitOfWork)
		{
		}
	}
}