﻿using System.Threading.Tasks;
using ODMWeb.DL;
using ODMWeb.ForeignApiManager;
using ODMWeb.Hangfire.RecurringJobs;
using Serilog;

namespace ODMWeb.Hangfire.Jobs
{
	public class UpdateSportDataTask : BaseHangfireTask<UpdateSportDataTask>
	{	
		public override async Task Run()
		{
			var service = new WebService();
			this.logger.Information("UpdateSportDataTask start.");
			var data = await service.GetSports();
			this.logger.Information("UpdateSportDataTask successful.");
			await this.unitOfWork.Sports.UpdateFromForeign(data);
		}

		public UpdateSportDataTask(IUnitOfWork unitOfWork) : base(unitOfWork)
		{
		}
	}
}