﻿using System.Threading.Tasks;
using ODMWeb.DL;
using ODMWeb.ForeignApiManager;
using ODMWeb.Hangfire.RecurringJobs;
using Serilog;

namespace ODMWeb.Hangfire.Jobs
{
	public class UpdateVenueDataTask : BaseHangfireTask<UpdateVenueDataTask>
	{
		public override async Task Run()
		{
			var service = new WebService();
			this.logger.Information("UpdateVenueDataTask start.");
			var data = await service.GetVenues();
			this.logger.Information("UpdateVenueDataTask successful.");
			await this.unitOfWork.Venues.UpdateFromForeign(data);
		}

		public UpdateVenueDataTask(IUnitOfWork unitOfWork) : base(unitOfWork)
		{
		}
	}
}