﻿using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using ODMWeb.DL;
using ODMWeb.DL.Entities.Serialization;

namespace ODMWeb.Hangfire.RecurringJobs
{
	public class CheckFileAvailabilityTask : BaseHangfireTask<CheckFileAvailabilityTask>
	{
		public CheckFileAvailabilityTask(IUnitOfWork unitOfWork) : base(unitOfWork)
		{
		}

		public override async Task Run()
		{
			var staticList = await this.unitOfWork.SerializedFiles.GetAll().Where(f => f.IsAvailable).ToListAsync();
			foreach (var record in staticList)
			{
				var path = record.FilePath;
				var exists = File.Exists(path);
				if (!exists)
				{
					logger.Warning("Record no longer available: {@SerializationRecordEntity}", record);
					record.IsAvailable = false;
				}
			}

			await this.unitOfWork.Save();
		}
	}
}