﻿using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities;
using ODMWeb.DL.Repositories.Interfaces;
using ODMWebService.DL.Entities.Enums;

namespace ODMWeb.Models.ItemViewModels
{
	public class CompetitionItemViewModel : ICompetition, IOdmDbItem
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public CompetitionTypeEnum CompetitionType { get; set; }
		public string Discipline { get; set; }
		public Gender Gender { get; set; }
		public string Race { get; set; }
		public int? SportId { get; set; }

		public bool IsModified { get; set; }

		public static CompetitionItemViewModel Create(CompetitionEntity entity)
		{
			return new CompetitionItemViewModel()
			{
				Id = entity.Id,
				CompetitionType = entity.CompetitionType,
				Discipline = entity.Discipline,
				Gender = entity.Gender,
				IsRemoved = entity.IsRemoved,
				Race = entity.Race,
				SportId = entity.SportId,
				IsModified = entity.IsModified
			};
		}
	}
}