﻿using System;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities;
using ODMWeb.DL.Entities.Interfaces;
using ODMWeb.DL.Repositories.Interfaces;

namespace ODMWeb.Models.ItemViewModels
{
	public class EventItemViewModel : IEvent, IOdmDbItem, ILocalDataLifecycle
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public DateTime? End { get; set; }
		public string Info { get; set; }
		public DateTime Start { get; set; }
		public int VenueId { get; set; }
		public int CompetitionId { get; set; }
		public string Title { get; set; }
		public VenueItemViewModel Venue { get; set; }


		public static EventItemViewModel Create(EventEntity entity)
		{
			return new EventItemViewModel()
			{
				Id = entity.Id,
				CompetitionId = entity.CompetitionId,
				End = entity.End,
				Info = entity.Info,
				IsRemoved = entity.IsRemoved,
				Start = entity.Start,
				VenueId = entity.VenueId,
				Venue = VenueItemViewModel.Create(entity.Venue),
				Title = entity.Title,
				IsSerialized = entity.IsSerialized,
				IsApproved = entity.IsApproved,
				IsModified = entity.IsModified
			};
		}

		public bool IsModified { get; set; }
		public bool IsApproved { get; set; }
		public bool IsSerialized { get; set; }
	}
}