﻿using System;
using System.ComponentModel.DataAnnotations;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities.Interfaces;
using ODMWeb.DL.Repositories.Interfaces;

namespace ODMWeb.Models.ItemViewModels
{
	public class MealItemViewModel : IMeal, IOdmDbItem, ILocalDataLifecycle
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }

		[Required(ErrorMessage = "CannotBeEmpty")]
		public DateTime Date { get; set; }
		public int MenuId { get; set; }
		[Required(ErrorMessage = "CannotBeEmpty"), MinLength(5, ErrorMessage = "Menu_MealTextMinLength")]
		public string Text { get; set; }
		public MealType Type { get; set; }
		public bool IsModified { get; set; }
		public bool IsApproved { get; set; }
		public bool IsSerialized { get; set; }
	}
}