﻿using System.Collections.Generic;
using System.Linq;
using ODM.Backend.Models.Models;
using ODMWeb.Models.Menu;

namespace ODMWeb.Models.ItemViewModels
{
	public class MenuViewModel
	{
		public MenuItemViewModel Menu { get; set; }
		public List<MealItemViewModel> Meals { get; set; }

		public string Name => Menu.Name;

		public static List<MenuViewModel> CreateList(List<MenuItemViewModel> menus, List<MealItemViewModel> meals)
		{
			List<MenuViewModel> output = new List<MenuViewModel>();
			
			foreach (var menu in menus)
			{
				output.Add(new MenuViewModel()
				{
					Menu = menu,
					Meals = meals.Where(m => m.MenuId == menu.Id).ToList()
				});
			}

			return output;
		}

		public static MenuViewModel CreateSingle(MenuItemViewModel menu, List<MealItemViewModel> meals)
		{
			MenuViewModel viewModel = new MenuViewModel(){Meals = meals, Menu = menu};

			return viewModel;
		}
	}
}