﻿using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities;
using ODMWeb.DL.Repositories.Interfaces;

namespace ODMWeb.Models.ItemViewModels
{
	public class VenueItemViewModel : IVenue
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public Address Address { get; set; }
		public Gps Location { get; set; }
		public string Name { get; set; }
		public VenueTypeEnum Type { get; set; }

		public static VenueItemViewModel Create(VenueEntity entity)
		{
			return new VenueItemViewModel()
			{
				Address = entity.Address,
				Id = entity.Id,
				IsRemoved = entity.IsRemoved,
				Location = entity.Location,
				Name = entity.Name,
				Type = entity.Type
			};
		}
	}
}