﻿using System;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;

namespace ODMWeb.Models.Log
{
	public class LogViewModel
	{
		public string Path { get; set; }
		public string Name { get; set; }
		public DateTime Date { get; set; }
		public long Size { get; set; }
		public LogViewModel(string path, FileInfo info)
		{
			this.Path = path;
			this.Size = info.Length;
			var pathArray = path.Split("\\");
			Name = pathArray.Last();
			var date = Regex.Match(Name, @"\d+").Value;
			var dateFormatted = $"{date.Substring(date.Length - 2, 2)}.{date.Substring(date.Length - 4, 2)}.{date.Substring(0, 4)}";
			Date = DateTime.Parse(dateFormatted);
		}
	}
}