﻿using System.Collections.Generic;
using AutoMapper;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.Models.ItemViewModels;

namespace ODMWeb.Models.Menu
{
	public class ModifyMenuViewModel : IMenu
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		public string Name { get; set; }
		public List<MealItemViewModel> Meals { get; set; }

		public static ModifyMenuViewModel Create(MenuViewModel model, IMapper mapper)
		{
			return new ModifyMenuViewModel()
			{
				Id = model.Menu.Id,
				Name = model.Menu.Name,
				Meals = mapper.Map<List<MealItemViewModel>>(model.Meals)
			};
		}
	}
}