﻿using System;
using System.ComponentModel.DataAnnotations;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities;

namespace ODMWeb.Models.Message
{
	public class CreateMessageViewModel : IMessage
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }

		[Required(ErrorMessage = "Message_DateRequired")]
		[Display(Name = "Message_Date")]
		public DateTime Date { get; set; } = DateTime.Now;

		[Required(ErrorMessage = "Message_TextRequired")]
		[Display(Name = "Message_Text")]
		public string Text { get; set; }

		[Required(ErrorMessage = "Message_TitleRequired")]
		[Display(Name = "Message_Title")]
		public string Title { get; set; }

		[Display(Name = "Message_IsImportant")]
		public bool IsImportant { get; set; }

		[Required(ErrorMessage = "Message_TopicRequired")]
		[Display(Name = "Message_Topic")]
		public MessageTopicEnum Topic { get; set; }

		public bool IsScheduled { get; set; }

		public MessageEntity CreateEntity()
		{
			return new MessageEntity()
			{
				Date = this.Date,
				IsImportant = this.IsImportant,
				IsRemoved = false,
				IsSerialized = false,
				IsApproved = false,
				IsModified = false,
				Text = this.Text,
				Title = this.Title,
				Topic = this.Topic
			};
		}
	}
}