﻿using System.Collections.Generic;
using System.Linq;
using AutoMapper;
using ODMWeb.DL.Entities;
using ODMWeb.Models.ItemViewModels;

namespace ODMWeb.Models.Message
{
	public class MessageListViewModel
	{
		public List<MessageItemViewModel> Messages { get; set; }

		public static MessageListViewModel Create(List<MessageEntity> entities, IMapper mapper)
		{
			MessageListViewModel output = new MessageListViewModel();

			output.Messages = mapper.Map<List<MessageItemViewModel>>(entities);
			output.Messages = output.Messages.OrderByDescending(m => m.Date).ToList();

			return output;
		}
	}
}