﻿using System;
using System.ComponentModel.DataAnnotations;
using ODM.Backend.Models.Enums;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities.Interfaces;

namespace ODMWeb.Models.Message
{
	public class ModifyMessageViewModel : IMessage
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }
		[Required(ErrorMessage = "Message_DateRequired")]
		[Display(Name = "Message_Date")]
		public DateTime Date { get; set; }
		[Required(ErrorMessage = "Message_TextRequired")]
		[Display(Name = "Message_Text")]
		public string Text { get; set; }
		[Required(ErrorMessage = "Message_TitleRequired")]
		[Display(Name = "Message_Title")]
		public string Title { get; set; }
		[Display(Name = "Message_IsImportant")]
		public bool IsImportant { get; set; }
		[Required(ErrorMessage = "Message_TopicRequired")]
		[Display(Name = "Message_Topic")]
		public MessageTopicEnum Topic { get; set; }

		public bool IsScheduled { get; set; }

		public static ModifyMessageViewModel Create(ODM.Backend.Models.Models.Message message)
		{
			return new ModifyMessageViewModel
			{
				Id = message.Id,
				Date = message.Date,
				Text = message.Text,
				Title = message.Title,
				IsImportant = message.IsImportant,
				Topic = message.Topic,
				IsRemoved = message.IsRemoved
			};
		}
	}
}