﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.DL.Entities;
using ODMWeb.Models.ItemViewModels;

namespace ODMWeb.Models.SideProgramme
{
	public class CreateEventViewModel : IEvent
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }

		[Display(Name = "Event_End")]
		public DateTime? End { get; set; }

		[Required(ErrorMessage = "Event_InfoRequired")]
		[Display(Name = "Event_Info")]
		public string Info { get; set; }

		[Required(ErrorMessage = "Event_StartRequired")]
		[Display(Name = "Event_Start")]
		public DateTime Start { get; set; }

		[Required(ErrorMessage = "Event_VenueRequired")]
		[Display(Name = "Event_Venue")]
		public int VenueId { get; set; }

		public int CompetitionId { get; set; }

		[Required(ErrorMessage = "Event_TitleRequired")]
		[Display(Name = "Event_Title")]
		public string Title { get; set; }

		public CompetitionItemViewModel Competition { get; set; }

		public List<Venue> Venues { get; set; }

		public static EventEntity CreateEntity(CreateEventViewModel viewModel)
		{
			return new EventEntity()
			{
				CompetitionId = viewModel.CompetitionId,
				End = viewModel.End,
				Start = viewModel.Start,
				Info = viewModel.Info,
				Title = viewModel.Title,
				IsSerialized = false,
				VenueId = viewModel.VenueId
			};
		}
	}
}