﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using ODM.Backend.Models.Models;
using ODM.Backend.Models.Models.Interfaces;
using ODMWeb.Models.ItemViewModels;
using ODMWebService.DL.Entities.Enums;

namespace ODMWeb.Models.SideProgramme
{
	public class ModifyEventViewModel : IEvent
	{
		public int Id { get; set; }
		public bool IsRemoved { get; set; }

		[Display(Name = "Event_End")]
		public DateTime? End { get; set; }

		[Required(ErrorMessage = "Event_InfoRequired")]
		[Display(Name = "Event_Info")]
		public string Info { get; set; }

		[Required(ErrorMessage = "Event_StartRequired")]
		[Display(Name = "Event_Start")]
		public DateTime Start { get; set; }

		[Required(ErrorMessage = "Event_VenueRequired")]
		[Display(Name = "Event_Venue")]
		public int VenueId { get; set; }

		public int CompetitionId { get; set; }

		[Required(ErrorMessage = "Event_TitleRequired")]
		[Display(Name = "Event_Title")]
		public string Title { get; set; }

		public CompetitionItemViewModel Competition { get; set; }

		public CompetitionTypeEnum CompetitionType { get; set; }

		public List<Venue> Venues { get; set; }

		public static ModifyEventViewModel Create(Event model)
		{
			return new ModifyEventViewModel()
			{
				Id = model.Id,
				IsRemoved = model.IsRemoved,
				End = model.End,
				Info = model.Info,
				Start = model.Start,
				VenueId = model.VenueId,
				CompetitionId = model.CompetitionId,
				Title = model.Title
			};
		}
	}
}