﻿using System.Collections.Generic;
using ODMWeb.DL.Entities;
using ODMWeb.Models.ItemViewModels;

namespace ODMWeb.Models.SideProgramme
{
	public class SideProgrammeViewModel
	{
		public List<EventItemViewModel> Events { get; set; }
		public CompetitionItemViewModel Competition { get; set; }


		public static SideProgrammeViewModel Create(CompetitionEntity entity, List<EventEntity> events)
		{
			var eventItems = new List<EventItemViewModel>();

			foreach (var eventEntity in events)
			{
				eventItems.Add(EventItemViewModel.Create(eventEntity));
			}

			var competition = CompetitionItemViewModel.Create(entity);

			return new SideProgrammeViewModel()
			{
				Events = eventItems,
				Competition = competition
			};
		}
	}
}