﻿using System.Reflection;
using Microsoft.Extensions.Localization;

namespace ODMWeb.SharedLocalization
{
	public class LocService
	{
		private readonly IStringLocalizer _localizer;

		public LocService(IStringLocalizerFactory factory)
		{
			var type = typeof(SharedResource);
			var assemblyName = new AssemblyName(type.GetTypeInfo().Assembly.FullName);
			_localizer = factory.Create(nameof(Resources.Resources), assemblyName.Name);
		}

		public LocalizedString Get(string key)
		{
			return _localizer[key];
		}
	}
	/// <summary>
	/// Dummy
	/// </summary>
	public class SharedResource
	{

	}
}